'From Squeak2.7 of 5 January 2000 [latest update: #1782] on 2 April 2000 at 9:41:24 pm'!
"Change Set:		Prefab
Date:			2 April 2000
Author:			Chris Reuter

This is Prefab, a set of Tk-style widgets for Morphic.  Please read the accompanying
documentation for more information.

This software is released under the same terms as Squeak itself.

"
!

Morph subclass: #ClippedImageMorph
	instanceVariableNames: 'form '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Prefab-Support'!
TextMorph subclass: #HookedTextMorph
	instanceVariableNames: 'hooks hookTarget dropKeys focusHook '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Prefab-Support'!
Object subclass: #PositionalBinding
	instanceVariableNames: 'window widget topDist botDist leftDist rightDist '
	classVariableNames: 'ClassVarName1 ClassVarName2 '
	poolDictionaries: ''
	category: 'Morphic-Prefab-Support'!
RectangleMorph subclass: #Prefab
	instanceVariableNames: 'manager foregroundColor tag '
	classVariableNames: 'Bitmaps '
	poolDictionaries: ''
	category: 'Morphic-Prefab'!
Prefab subclass: #PrefabCheckButton
	instanceVariableNames: 'switch label selectResponse deselectResponse '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Prefab'!
Prefab subclass: #PrefabEdit
	instanceVariableNames: 'text textTransform vScrollBar scrollPosition selection '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Prefab'!
Prefab subclass: #PrefabEntry
	instanceVariableNames: 'text textTransform returnResponse '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Prefab'!
Prefab subclass: #PrefabFrame
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Prefab'!
Prefab subclass: #PrefabLabel
	instanceVariableNames: 'labelMorph labelMorphMaxSize orientation imageID '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Prefab'!
PrefabLabel subclass: #PrefabButton
	instanceVariableNames: 'response clickedIn action '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Prefab'!
Prefab subclass: #PrefabListBox
	instanceVariableNames: 'transform items scrollPosition elementHeight indices selection selectionMode selectColor selectForeground vScrollBar selectResponse '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Prefab'!
Prefab subclass: #PrefabManager
	instanceVariableNames: 'resizer minSize maxSize title beingResized '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Prefab-Managers'!
PrefabManager subclass: #Calculator
	instanceVariableNames: 'display clearFirst '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Prefab-Examples'!
PrefabManager subclass: #EditorFrame
	instanceVariableNames: 'editor scroller '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Prefab-Examples'!
PrefabManager subclass: #PrefabConstruction
	instanceVariableNames: 'gridSize isGridded '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Prefab-Construction'!
SystemWindow subclass: #PrefabManagerWrapper
	instanceVariableNames: 'client '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Prefab-Support'!
PrefabCheckButton subclass: #PrefabRadioButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Prefab'!
Object subclass: #PrefabResizer
	instanceVariableNames: 'parcels window '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Prefab-Resizing'!
PrefabResizer subclass: #FixedDistanceResizer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Prefab-Resizing'!
Object subclass: #PrefabResponse
	instanceVariableNames: 'action target args '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Prefab-Support'!
Prefab subclass: #PrefabScrollBar
	instanceVariableNames: 'slider sliderShadow orientation forwardButton backwardButton response ratio stepSize cnhDirection ignoreSteps '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Prefab'!
PrefabResizer subclass: #RubberSheetResizer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Prefab-Resizing'!
PrefabButton subclass: #SwitchElement
	instanceVariableNames: 'otherColor isClicked toggleMode '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Prefab-Support'!
PrefabManager subclass: #TestWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Prefab-Examples'!

!Character methodsFor: 'testing' stamp: 'cr 1/23/2000 18:47'!
isPrintable
	"Answer whether this character is printable."
	^value >= 32 and: [value < 127].! !


!Morph methodsFor: 'classification' stamp: 'cr 7/9/1999 21:47'!
isPrefab
	^false.! !


!ClippedImageMorph commentStamp: '<historical>' prior: 0!
I am a morph that displays an image.  If I'm smaller than the image, I display only
a part of it, centered.!

!ClippedImageMorph reorganize!
('other' drawOn: extent: initialize readFromFile releaseCachedState)
('accessing' form form: newForm:)
!


!ClippedImageMorph methodsFor: 'other' stamp: 'cr 6/30/1999 23:31'!
drawOn: aCanvas

	| sourceRect |
	sourceRect := (Rectangle center: form boundingBox center extent: self extent) .
					"translatedToBeWithin: (0@0 extent: form extent)."
	aCanvas image: form at: self bounds origin sourceRect: sourceRect rule: Form paint.! !

!ClippedImageMorph methodsFor: 'other' stamp: 'cr 6/30/1999 23:20'!
extent: aPoint
	"Set extent.  I may not be bigger than my form."
	aPoint > form extent
		ifFalse: [super extent: aPoint].! !

!ClippedImageMorph methodsFor: 'other' stamp: 'cr 6/30/1999 23:22'!
initialize
	super initialize.
	self form: ClippedImageMorph defaultForm.! !

!ClippedImageMorph methodsFor: 'other' stamp: 'cr 6/30/1999 23:25'!
readFromFile
	| fileName |
	fileName _ FillInTheBlank
		request: 'Please enter the image file name'
		initialAnswer: 'fileName'.
	fileName isEmpty ifTrue: [^ self].
	self form: (Form fromFileNamed: fileName).
! !

!ClippedImageMorph methodsFor: 'other' stamp: 'cr 6/30/1999 22:04'!
releaseCachedState

	super releaseCachedState.
	form hibernate.
! !

!ClippedImageMorph methodsFor: 'accessing' stamp: 'cr 6/30/1999 22:02'!
form
	"Return value of instance variable 'form'"
	^form! !

!ClippedImageMorph methodsFor: 'accessing' stamp: 'cr 7/4/1999 17:00'!
form: newValue
	"Set value of instance variable 'form'."
	form := newValue.

	"Make sure I'm exactly the size of my new form."
	self extent: form extent.
! !

!ClippedImageMorph methodsFor: 'accessing' stamp: 'cr 6/30/1999 23:41'!
newForm: aForm
	"Change form.  Gets called by some routines."
	self form: aForm.
! !


!ClippedImageMorph class methodsFor: 'as yet unclassified' stamp: 'cr 6/30/1999 23:12'!
defaultForm
	"Return a 1-bit Form of the mouse."
	^ Form extent: 30@29 depth: 1
			fromArray: #( 0 0 0 0 0 335544480 33554688 0 8389632 0 
							272631840 268435488 268435488 269492256 
							3698688 141615168 3698688 0 0 1072906224 
							2164754436 403144800 0 67108992 0 0 0 0 0)
			offset: 0@0.! !


!HookedTextMorph commentStamp: 'cr 2/27/2000 18:52' prior: 0!
This is a kind of TextMorph intended to be used by instances of PrefabEntry and PrefabEdit to display text.
In addition to displaying text and allowing it to be edited, it also notifies its owner when certain
things happen, e.g. a key-press.  That is, it provide hooks to common editing events.

It's an ugly hack on top of TextMorph but the only other way to do it that I can think of involves
writing a more Prefab-friendly version of TextMorph and while that might in fact be a fun project,
it's more work than I'm willing to do right now.

!

!HookedTextMorph reorganize!
('all' addHookFor:withMessage: drawNullTextOn: dropKeys dropKeys: focusHook: hookTarget: initialize keyStroke: keyboardFocusChange: removeHookFor:)
!


!HookedTextMorph methodsFor: 'all' stamp: 'cr 1/23/2000 13:10'!
addHookFor: aChar withMessage: aSymbol
	"Set this morph to notify its owner when 'aChar' is hit."
	hooks at: aChar asciiValue put: aSymbol.! !

!HookedTextMorph methodsFor: 'all' stamp: 'cr 2/13/2000 18:57'!
drawNullTextOn: aCanvas
	"Avoid that ugly pink background."
	aCanvas paragraph: self paragraph bounds: bounds color: color
! !

!HookedTextMorph methodsFor: 'all' stamp: 'cr 2/19/2000 22:46'!
dropKeys
	"If true, eat all keystrokes that haven't been hooked."
	^dropKeys! !

!HookedTextMorph methodsFor: 'all' stamp: 'cr 2/7/2000 22:59'!
dropKeys: aBoolean
	"If true, eat all keystrokes that haven't been hooked."
	dropKeys := aBoolean.! !

!HookedTextMorph methodsFor: 'all' stamp: 'cr 2/13/2000 18:03'!
focusHook: aMessage
	focusHook := aMessage.
! !

!HookedTextMorph methodsFor: 'all' stamp: 'cr 1/23/2000 07:55'!
hookTarget: aPrefabEntry
	"Set the object to notify "
	hookTarget := aPrefabEntry.! !

!HookedTextMorph methodsFor: 'all' stamp: 'cr 2/13/2000 18:57'!
initialize
	super initialize.

	hooks := Array new: 256.
	dropKeys := false.
! !

!HookedTextMorph methodsFor: 'all' stamp: 'cr 2/7/2000 22:56'!
keyStroke: evt
	| msg newKey before after |
	"Intercept the keystroke.  If there's a hook (i.e. a PrefabResponse) defined for this key, execute it and
	 hand the return value off to the superclass's keyStroke (unless it's nil, in which case we drop it on 
	 the floor.)"

	before := self editor selectionInterval.

	(hookTarget notNil and: [(msg := hooks at: evt keyValue) notNil])
		ifTrue: [
			newKey := hookTarget perform: msg with: evt keyValue.

			"Eat the event if nil is returned."
			newKey
				ifFalse: [^self].

			"To do:  some way of letting the hook modify the key value.  Maybe."
		].

	"Pass on this event if dropKeys is false.  This is used to do read-only text panes."
	dropKeys
		ifFalse: [super keyStroke: evt].

	after := self editor selectionInterval.

	hookTarget ifNotNil: [hookTarget scrollAfterSelection: after changedFrom: before].

	"(self editor selectionInterval first printString, '   ') displayAt: 0@0."

! !

!HookedTextMorph methodsFor: 'all' stamp: 'cr 3/8/2000 03:23'!
keyboardFocusChange: aBool
	"Allow the owner to do something if focus changes."
	(focusHook notNil and: [hookTarget notNil])
		ifTrue: [hookTarget perform: focusHook with: aBool].

	^super keyboardFocusChange: aBool.! !

!HookedTextMorph methodsFor: 'all' stamp: 'cr 1/23/2000 13:10'!
removeHookFor: aChar
	"Set this morph to not notify its owner when 'aChar' is hit."
	hooks at: aChar asciiValue put: nil.! !


!PositionalBinding commentStamp: 'cr 2/27/2000 18:44' prior: 0!
This class implements an object which maintains a list of which edges of an associated Prefab 
widget are to be fixed relative to the right or bottom edges of its manager and can calculate
the bounds of the widget given the managers bounds.

This class is used exclusively by FixedDistanceResizer.!

!PositionalBinding reorganize!
('position calculation' newBounds)
('fixing' fixBottom fixLeft fixRight fixTop)
('accessing' botDist: leftDist: rightDist: topDist: widget: window:)
!


!PositionalBinding methodsFor: 'position calculation' stamp: 'cr 2/26/2000 22:50'!
newBounds
	| rect ib |
	"Return a rectangle containing the bounds for the widget given the current size of the outer
	 window."

	rect := widget bounds.
	ib := window innerBounds.

	topDist ifNotNil: [rect := rect withTop: ib bottom - topDist].
	botDist ifNotNil: [rect := rect withBottom: ib bottom - botDist].
	leftDist ifNotNil: [rect := rect withLeft: ib right - leftDist].
	rightDist ifNotNil: [rect := rect withRight: ib right - rightDist].

	^rect
! !

!PositionalBinding methodsFor: 'fixing' stamp: 'cr 2/20/2000 20:05'!
fixBottom
	botDist := window innerBounds bottom - widget bounds bottom.! !

!PositionalBinding methodsFor: 'fixing' stamp: 'cr 2/20/2000 20:03'!
fixLeft
	leftDist := window innerBounds right - widget bounds left.! !

!PositionalBinding methodsFor: 'fixing' stamp: 'cr 2/20/2000 20:02'!
fixRight
	rightDist := window innerBounds right - widget bounds right.! !

!PositionalBinding methodsFor: 'fixing' stamp: 'cr 2/20/2000 20:05'!
fixTop
	topDist := window innerBounds bottom - widget bounds top.! !

!PositionalBinding methodsFor: 'accessing' stamp: 'cr 2/20/2000 19:57'!
botDist: anInteger
	botDist := anInteger! !

!PositionalBinding methodsFor: 'accessing' stamp: 'cr 2/20/2000 19:57'!
leftDist: anInteger
	leftDist := anInteger! !

!PositionalBinding methodsFor: 'accessing' stamp: 'cr 2/20/2000 19:57'!
rightDist: anInteger
	rightDist := anInteger! !

!PositionalBinding methodsFor: 'accessing' stamp: 'cr 2/20/2000 19:56'!
topDist: anInteger
	topDist := anInteger! !

!PositionalBinding methodsFor: 'accessing' stamp: 'cr 2/20/2000 20:00'!
widget: aPrefab
	widget := aPrefab! !

!PositionalBinding methodsFor: 'accessing' stamp: 'cr 2/20/2000 20:00'!
window: aConstruction
	window := aConstruction! !


!PositionalBinding class reorganize!
('instance creation' for:in:)
!


!PositionalBinding class methodsFor: 'instance creation' stamp: 'cr 2/20/2000 20:18'!
for: aWidget in: aManager
	^super new
		window: aManager;
		widget: aWidget;
		yourself.! !


!Prefab commentStamp: '<historical>' prior: 0!
This is the abstract base class for all Prefabs.  It implements the common API for all Prefabs.

Prefabs are widgets designed to simplify the writing of conventional user interfaces.  Each is a common
GUI object with a simple and consistant (I hope) interface.  Furthermore, they provide a means to generate
source code to recreate their layout.

Unless you are working on the Prefab system itself, you should only ever need to send a Prefab instance
a message in one of the API categories.  (And if you need to do something that isn't provided by the API,
add it and send me (cgreuter@csclub.uwaterloo.ca) a change set.)


Here's the minimal manual:

        0) Go to a Morphic world
        1) From the "New Morph...">"Prefab" menu, create a PrefabConstruction.
                Resize it as desired.
        2) Create whichever control you want from the Prefab menu.  (Avoid
                "Prefab-Support" and "Prefab-Examples").
        3) If the control isn't purely decorative, use the "Set Tag" menu item
                to give it a unique identifier.  This gets turned into a Symbol.
        4) Resize, recolor, or otherwise configure the control as you see fit
                using the various main menu options.
        5) Drop the control onto the PrefabConstruction.
        6) Repeat steps 2-5 until bored.
        7) From the PrefabConstruction's menu, select "Construction Menu" > 
                "Display Construction Source".  This will open up a workspace containing
                the source code that recreates the GUI layout.
        8) Paste the source code wherever convenient.  This may be a subclass of
                PrefabManager if convenient.  However, the argument passed to the
                method must be a PrefabManager.
        9) To add semantic actions or otherwise programmatically tweak individual
                controls, use PrefabManager>>clientWithTag: with the tag as
                argument.  The tag must be a symbol.  This is a bit slow so you might
                want to store reference to often-referenced controls in an instance variable.
                
                You should only need to use those methods in the API categories to modify
                Prefab controls.

To edit an existing dialog:

        Calculator new buildOn: (PrefabConstruction new openInWorld)    

(Substitute your creation for "Calculator").

To give a PrefabManager a title bar, use #newInSystemWindow or #newInSystemWindowNamed:.

E.g. "Calculator newInSystemWindowNamed: 'My Calculator'.")



!

!Prefab reorganize!
('initialization' initialize)
('API' color color: extent extent: foregroundColor foregroundColor: tag tag:)
('accessing' manager)
('construction' attributeList)
('other' justDroppedInto:event:)
('tests' isHollow isManaged isPrefab)
('placement' hollowRegion parcelRequired)
('menu' addAddHandMenuItemsForHalo:hand: addCustomMenuItems:hand: changeColorOfAttribute: setTag)
!


!Prefab methodsFor: 'initialization' stamp: 'cr 1/8/2000 02:55'!
initialize

	super initialize.

	self borderWidth: Prefab defaultBorderWidth.
	self borderColor: Prefab backgroundColor.
	self color: Prefab backgroundColor.
	
	foregroundColor := Prefab foregroundColor.
! !

!Prefab methodsFor: 'API' stamp: 'cr 1/9/2000 21:58'!
color
	"Get color."
	^super color.

	"This is here so that you can tell by looking at the 'API' section that #extent: is 'officially'
	 an attribute of Prefab.  If this slows things down too much (unlikely), you can remove it
	 without breaking anything."! !

!Prefab methodsFor: 'API' stamp: 'cr 1/9/2000 21:57'!
color: aColor
	"Set color."
	^super color: aColor.

	"This is here so that you can tell by looking at the 'API' section that #extent: is 'officially'
	 an attribute of Prefab.  If this slows things down too much (unlikely), you can remove it
	 without breaking anything."! !

!Prefab methodsFor: 'API' stamp: 'cr 1/9/2000 21:57'!
extent
	"Get extent."
	^super extent.

	"This is here so that you can tell by looking at the 'API' section that #extent: is 'officially'
	 an attribute of Prefab.  If this slows things down too much (unlikely), you can remove it
	 without breaking anything."! !

!Prefab methodsFor: 'API' stamp: 'cr 1/9/2000 21:57'!
extent: aPoint
	"Set extent."
	^super extent: aPoint

	"This is here so that you can tell by looking at the 'API' section that #extent: is 'officially'
	 an attribute of Prefab.  If this slows things down too much (unlikely), you can remove it
	 without breaking anything."! !

!Prefab methodsFor: 'API' stamp: 'cr 1/4/2000 23:48'!
foregroundColor
	"Color of whatever is in the foreground."
	^foregroundColor
! !

!Prefab methodsFor: 'API' stamp: 'cr 1/4/2000 23:49'!
foregroundColor: aColor
	"Color of whatever is in the foreground."
	foregroundColor := aColor
! !

!Prefab methodsFor: 'API' stamp: 'cr 1/4/2000 23:50'!
tag
	"The tag is a symbol which, if set, is a unique identifier for this Prefab in this Manager.
	 That is, only one Prefab in a Manager may hold a particular tag at a time.  Uniqueness
	 is NOT enforced so be careful.  The purpose of these is to make it easy to find individual
	 GUI bits after the window has been constructed."
	^tag
! !

!Prefab methodsFor: 'API' stamp: 'cr 1/4/2000 23:50'!
tag: aSymbol
	"The tag is a symbol which, if set, is a unique identifier for this Prefab in this Manager.
	 That is, only one Prefab in a Manager may hold a particular tag at a time.  Uniqueness
	 is NOT enforced so be careful.  The purpose of these is to make it easy to find individual
	 GUI bits after the window has been constructed."

	tag ifNotNil: [
		(tag class ~~ Symbol or: [(aSymbol at: 1) isLetter not])
			ifTrue: [
				self error: 'tag ', 
					aSymbol storeString, 
					' must be a symbol starting with a letter'.
			]
	].


	tag := aSymbol.
! !

!Prefab methodsFor: 'accessing' stamp: 'cr 3/19/2000 19:59'!
manager
	"Return the manager of this Prefab or nil it it's unmanaged.  For a Prefab to be managed, it must be registered
	 as a client of the manager AND must be in the Manager's submorph hierarchy."
	| o |

	o := self owner.

	"Skip up past any containing frames we might find."
	[(o isKindOf: Prefab) and: [o isHollow]] whileTrue: [o := o owner].

	((o isKindOf: PrefabManager) and: [o hasClient: self])
		ifTrue: [^o].

	^nil.! !

!Prefab methodsFor: 'construction' stamp: 'cr 1/8/2000 02:55'!
attributeList
	"Return a collection of pairs of (attributeName: value) that can be used to reconstruct
	 this prefab completely."
	^OrderedCollection new
		add: {#extent:. self extent};
		add: {#color:. self color};
		add: {#foregroundColor:. self foregroundColor};
		add: {#tag:. self tag};
		yourself. ! !

!Prefab methodsFor: 'other' stamp: 'cr 1/18/2000 23:59'!
justDroppedInto: aMorph event: evt
	| m |
	"If necessary, fix up the owner/manager invariant."

	"Skip any hollow morphs that may be between this one and the Manager."
	m := aMorph.
	[(m isKindOf: Prefab) and: [m isHollow]] whileTrue: [m := m owner].

	"If it's a PrefabManager and I'm not a client, add me as a client."
	((m isKindOf: PrefabManager) and: [(m hasClient: self) not])
		ifTrue: [m addClient: self].

	^super justDroppedInto: aMorph event: evt.
	! !

!Prefab methodsFor: 'tests' stamp: 'cr 7/6/1999 19:13'!
isHollow	
	"Is self hollow?  (See comment for hollowRegion.)"
	^ self hollowRegion notNil.! !

!Prefab methodsFor: 'tests' stamp: 'cr 7/4/1999 16:32'!
isManaged
	^manager notNil.! !

!Prefab methodsFor: 'tests' stamp: 'cr 7/9/1999 21:49'!
isPrefab
	^true! !

!Prefab methodsFor: 'placement' stamp: 'cr 7/5/1999 22:48'!
hollowRegion
	"Some prefabs are hollow and allow other prefabs to be placed inside their bounds.  If
	 this is supported, return a rectangle containing this region.  A good (only?) example of
	 a morph that could use this sort of behaviour is a decorative frame in a dialog box."
	^nil.! !

!Prefab methodsFor: 'placement' stamp: 'cr 7/5/1999 22:45'!
parcelRequired
	"Region of window space this morph will occupy."
	^self bounds.
! !

!Prefab methodsFor: 'menu' stamp: 'cr 1/8/2000 02:28'!
addAddHandMenuItemsForHalo: aMenu hand: aHandMorph
	"Add halo menu items to be handled by the invoking hand. This is here mainly to override the
	 superclass's version and so remove options that are inappropriate for Prefabs."

	aMenu addLine.
	aMenu add: 'copy to paste buffer' action: #copyToPasteBuffer.
	aMenu add: 'copy Postscript' action: #clipPostscript.
	aMenu add: 'print PS to file...' target: self selector: #printPSToFile.
! !

!Prefab methodsFor: 'menu' stamp: 'cr 1/8/2000 02:57'!
addCustomMenuItems: aCustomMenu hand: aHandMorph
"	super addCustomMenuItems: aCustomMenu hand: aHandMorph."
	
	aCustomMenu addLine;
		add: 'Set tag' target: self action: #setTag;
		add: 'Set background color' target: self selector: #changeColorOfAttribute: argument: #color;
		add: 'Set foreground color' target: self selector: #changeColorOfAttribute: argument: #foregroundColor.! !

!Prefab methodsFor: 'menu' stamp: 'cr 1/8/2000 02:50'!
changeColorOfAttribute: aSelector

	| oc |
	oc := self perform: aSelector.
	ColorPickerMorph new
		sourceHand: self activeHand;
		target: self;
		selector: (aSelector,':') asSymbol;
		originalColor: oc;
		addToWorld: self world
			near: self fullBounds! !

!Prefab methodsFor: 'menu' stamp: 'cr 7/11/1999 20:59'!
setTag
	"Prompt the user for a tag name."
	| newTag |
	newTag := FillInTheBlank request: 'Enter new tag'
				initialAnswer: tag asString.

	newTag isEmpty
		ifFalse: [self tag: newTag asSymbol].
			! !


!Prefab class reorganize!
('class initialization' initialize loadImageLibrary)
('API-image library' addForm:named: addFormFromFile:named: formNamed: loadImagesIn:)
('misc' includeInNewMorphMenu)
('constants-defaults' activateColor backgroundColor checkButtonCheckedColor checkButtonExtent defaultBorderWidth defaultButtonBorderWidth defaultFrameBorderWidth defaultInnerBorderWidth defaultListBoxSelectionColor defaultListBoxSelectionForeground defaultScrollbarLength defaultScrollbarWidth foregroundColor listBoxElementHeight managerFrameClass radioButtonCheckedColor radioButtonCheckedColour radioButtonExtent scrollbarBackgroundColor scrollbarBorderWidth scrollbarSliderColor windowFrameBorderWidth windowFrameColor windowFrameTextColor windowFrameTitleBarHeight)
('utilities' queryPoint:named:)
!


!Prefab class methodsFor: 'class initialization' stamp: 'cr 9/2/1999 20:17'!
initialize
	"Initialize me."

	"Prefab initialize."
	
	Bitmaps := Dictionary new.
	self loadImageLibrary.! !

!Prefab class methodsFor: 'class initialization' stamp: 'cr 11/1/1999 00:08'!
loadImageLibrary
	"Load the 'built-in' images from the images directory."

	| dir |
	dir := FileDirectory default directoryNamed: 'images'.

	"Add entries as necessary."
	#(bang doNotEnter info question upArrow downArrow leftArrow rightArrow) do: [ :imageTag |
		self addFormFromFile: (dir fullNameFor: imageTag asString, '.xpm') named: imageTag.
	].

	"Prefab loadImageLibrary"
! !

!Prefab class methodsFor: 'API-image library' stamp: 'cr 7/3/1999 21:47'!
addForm: aForm named: aSymbol
	"Add a form to the image dictionary."
	Bitmaps at: aSymbol put: aForm.! !

!Prefab class methodsFor: 'API-image library' stamp: 'cr 7/3/1999 21:58'!
addFormFromFile: aFileName named: aSymbol
	self addForm: (ImageReadWriter formFromFileNamed: aFileName) named: aSymbol! !

!Prefab class methodsFor: 'API-image library' stamp: 'cr 7/3/1999 21:47'!
formNamed: aSymbol
	^Bitmaps at: aSymbol.! !

!Prefab class methodsFor: 'API-image library' stamp: 'cr 12/10/1999 20:24'!
loadImagesIn: aDir
	"Load the 'built-in' images from the images directory."

	| dir tag |
	dir := FileDirectory on: aDir.

	"Add entries as necessary."
	dir fileNames do: [ :filename |
		(FileDirectory extensionFor: filename) = 'xpm'
			ifTrue: [
				tag := (FileDirectory baseNameFor: (filename copyFrom: 1 to: filename size - 4)) asSymbol.
				self addFormFromFile: (dir fullNameFor: filename) named: tag.
			].
	].


! !

!Prefab class methodsFor: 'misc' stamp: 'cr 7/10/1999 17:39'!
includeInNewMorphMenu
	"Include my subclasses but not me"
	^ self ~~ Prefab! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 6/26/1999 22:12'!
activateColor
	^ (Color r: 0.969 g: 0.969 b: 0.969)! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 10/31/1999 22:49'!
backgroundColor
	"Background color for most morphs."
	^ (Color r:  0.851 g:  0.851 b:  0.851)! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 7/24/1999 18:00'!
checkButtonCheckedColor
	^Color green.! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 7/24/1999 17:29'!
checkButtonExtent
	"Dimensions of the switch part of a PrefabCheckButton."
	^10@10.! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 7/4/1999 23:39'!
defaultBorderWidth
	^1! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 7/4/1999 23:39'!
defaultButtonBorderWidth
	^2! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 7/13/1999 23:06'!
defaultFrameBorderWidth
	^1! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 7/4/1999 23:37'!
defaultInnerBorderWidth
	^2! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 12/20/1999 23:13'!
defaultListBoxSelectionColor
	^self backgroundColor darker ! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 12/20/1999 22:37'!
defaultListBoxSelectionForeground
	"Default foreground colour for selected listbox elements."
	^Color red.! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 11/1/1999 00:29'!
defaultScrollbarLength
	"Initial length (in the axis the slider moves) of a scrollbar when created."
	^230! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 11/1/1999 00:30'!
defaultScrollbarWidth
	"Width (opposite to the axis the slider moves) of a scrollbar."
	^16! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 10/31/1999 22:49'!
foregroundColor
	"Foreground color for most prefab morphs."
	^Color black! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 12/15/1999 23:48'!
listBoxElementHeight
	"Height in pixels of a listbox element."
	^12! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 3/26/2000 15:53'!
managerFrameClass
	"Return the class that provides managers with title bars and the like."
	^PrefabManagerWrapper   "Warning: This *must* be a subclass of SystemWindow or else things break."! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 7/24/1999 23:47'!
radioButtonCheckedColor
	^Color red.! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 7/18/1999 18:08'!
radioButtonCheckedColour
	^Color red.! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 7/25/1999 00:08'!
radioButtonExtent
	^15@10.! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 10/31/1999 22:53'!
scrollbarBackgroundColor
	"Background color for the trough of a scroll-bar."
	^ (Color r:  0.6 g:  0.6 b:  0.8)! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 10/31/1999 22:53'!
scrollbarBorderWidth
	"Width of scrollbar elements."
	^ 3! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 11/4/1999 00:08'!
scrollbarSliderColor
	"Background color for the slider of a scroll-bar."
	^ Color veryLightGray.! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 7/13/1999 22:55'!
windowFrameBorderWidth
	^9! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 7/13/1999 22:55'!
windowFrameColor
	"Colour of top-level frames."
	^ Color r: 0.452 g: 0.742 b: 0.839.

	"Color r: 0.065 g: 0.839 b: 0.839"! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 7/13/1999 22:55'!
windowFrameTextColor
	"Colour of top-level frames."
	^ Color black! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 7/13/1999 22:55'!
windowFrameTitleBarHeight
	^24! !

!Prefab class methodsFor: 'utilities' stamp: 'cr 7/16/1999 23:20'!
queryPoint: initialPoint named: attrName
	"Query the user for a point other than 'initialPoint',  Return initialPoint
	 on cancellation or failure."
	| newPoint |
	newPoint := FillInTheBlank request: 'Enter a new value for ', attrName
					initialAnswer: initialPoint storeString.

	newPoint isEmpty
		ifTrue: [^initialPoint]
		ifFalse: [^Point readFromString: newPoint].! !


!PrefabCheckButton commentStamp: 'cr 2/27/2000 19:34' prior: 0!
This class implements labeled buttons that can be checked on unchecked by clicking.  The interface
is identical to that of PrefabButton except that you can assign separate actions to the
button's selection and deselection and query instances at any time as to whether they are
selected and/or set their selection.

See the class comment of PrefabResponse for an explanation of how callbacks work.

!

!PrefabCheckButton reorganize!
('initialization' initialize)
('API' color: contentOrientation contentOrientation: extent: image: isSelected isSelected: text:)
('API-Actions' actionDeselected: actionSelected: args: target:)
('event handling' clicked)
('menu' addCustomMenuItems:hand: setImage setImageFile setOrientation setText)
('private' fixedHeight labelOrigin minimumWidth switchPosition)
('change reporting' layoutChanged)
('construction' attributeList)
!


!PrefabCheckButton methodsFor: 'initialization' stamp: 'cr 2/27/2000 19:26'!
initialize
	
	super initialize.

	"Create the responses."
	selectResponse := PrefabResponse new.
	deselectResponse := PrefabResponse new.

	switch := SwitchElement new
				clickedColor: Prefab checkButtonCheckedColor;
				action: #clicked;
				target: self;
				extent: Prefab checkButtonExtent;
				color: self color;
				yourself.

	label := PrefabLabel new
				text: 'A Check-Button';
				contentOrientation: #left;
				borderWidth: 0;
				color: self color;
				yourself.

	self addMorph: switch;
		addMorph: label.

	"Resize to something reasonable.  Height is fixed so we don't care about it."
	self extent: (label idealExtent x + ((self borderWidth + self switchPosition x) * 3)) @ 0.

	self borderWidth: 0.

! !

!PrefabCheckButton methodsFor: 'API' stamp: 'cr 7/24/1999 23:51'!
color: aColor
	"Set color.  Set label's color too."
	label ifNotNil: [label color: aColor].
	switch ifNotNil: [switch unclickedColor: aColor].
	^super color: aColor.! !

!PrefabCheckButton methodsFor: 'API' stamp: 'cr 1/8/2000 01:48'!
contentOrientation
	"Get position of the displayable within the label.  Options are #left, #right and #center
	 and they determine where (horizontally) the image or text is placed inside the bounds
	 of the label (or button) iff there is extra space."
	^label contentOrientation.! !

!PrefabCheckButton methodsFor: 'API' stamp: 'cr 3/18/2000 11:48'!
contentOrientation: aSymbol
	"Set position of the displayable within the label.  Options are #left, #right and #center
	 and they determine where (horizontally) the image or text is placed inside the bounds
	 of the label (or button) iff there is extra space."
	label contentOrientation: aSymbol.! !

!PrefabCheckButton methodsFor: 'API' stamp: 'cr 7/24/1999 18:54'!
extent: aPoint
	"Set extent to aPoint, making sure that it's not resized smaller than the specified minimum."

	^super extent: (aPoint x max: self minimumWidth) @ self fixedHeight.! !

!PrefabCheckButton methodsFor: 'API' stamp: 'cr 10/24/1999 20:44'!
image: aSymbolOrFilenameOrForm
	"Set label to image identified by aSymbolOrFilenameOrForm."
	label image: aSymbolOrFilenameOrForm.
! !

!PrefabCheckButton methodsFor: 'API' stamp: 'cr 7/25/1999 00:20'!
isSelected
	^switch isClicked! !

!PrefabCheckButton methodsFor: 'API' stamp: 'cr 2/27/2000 19:39'!
isSelected: aBoolean
	"Set selection"
	switch isClicked: aBoolean.
	self clicked.! !

!PrefabCheckButton methodsFor: 'API' stamp: 'cr 7/24/1999 19:42'!
text: aString
	"Set label text to aString."
	label text: aString.
! !

!PrefabCheckButton methodsFor: 'API-Actions' stamp: 'cr 2/27/2000 19:31'!
actionDeselected: aBlockOrSymbol
	"Action to take when un-checked."
	deselectResponse action: aBlockOrSymbol! !

!PrefabCheckButton methodsFor: 'API-Actions' stamp: 'cr 2/27/2000 19:31'!
actionSelected: aBlockOrSymbol
	"Action to take when checked."
	selectResponse action: aBlockOrSymbol.! !

!PrefabCheckButton methodsFor: 'API-Actions' stamp: 'cr 2/27/2000 19:27'!
args: anArray
	"Set args to array of arguments to be used as parameters by the actions."
	selectResponse args: anArray.
	deselectResponse args: anArray! !

!PrefabCheckButton methodsFor: 'API-Actions' stamp: 'cr 2/27/2000 19:33'!
target: anObject
	"The object to which the select and unselect actions are sent iff they are message
	 names."
	selectResponse target: anObject.
	deselectResponse target: anObject.! !

!PrefabCheckButton methodsFor: 'event handling' stamp: 'cr 2/27/2000 19:29'!
clicked
	"Button was clicked or state changed for some other reason."

	self isSelected
		ifTrue: [selectResponse invoke]
		ifFalse: [deselectResponse invoke]


! !

!PrefabCheckButton methodsFor: 'menu' stamp: 'cr 7/24/1999 23:12'!
addCustomMenuItems: aCustomMenu hand: aHandMorph
	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	
	aCustomMenu add: 'Set text' target: self action: #setText;
		add: 'Set orientation' target: self action: #setOrientation;
		add: 'Set image from image dictionary' target: self action: #setImage;
		add: 'Set image from file' target: self action: #setImageFile.! !

!PrefabCheckButton methodsFor: 'menu' stamp: 'cr 7/24/1999 23:12'!
setImage
	"Set the label's image."
	| newImage |
	newImage := FillInTheBlank request: 'Enter new label image (as a dictionary entry)'.
	newImage isEmpty
		ifFalse: [self image: newImage asSymbol].
			! !

!PrefabCheckButton methodsFor: 'menu' stamp: 'cr 10/24/1999 20:43'!
setImageFile
	"Set the label's image to the file in the given path."
	| newImage |
	newImage := FillInTheBlank request: 'Enter new image file name'.
	newImage isEmpty
		ifFalse: [self image: newImage].
			! !

!PrefabCheckButton methodsFor: 'menu' stamp: 'cr 7/24/1999 23:12'!
setOrientation
	
	| orientations index |
	orientations := #(left right centered).

	index := (PopUpMenu labels: 'left\right\centered' withCRs)
				startUpWithCaption: 'Pick an orientation'.

	self orientation: (orientations at: index).! !

!PrefabCheckButton methodsFor: 'menu' stamp: 'cr 7/24/1999 23:12'!
setText
	"Set the label's text."
	| newText |
	newText := FillInTheBlank request: 'Enter new label text'.
	newText isEmpty
		ifFalse: [self text: newText].
			! !

!PrefabCheckButton methodsFor: 'private' stamp: 'cr 7/24/1999 18:58'!
fixedHeight
	"Return the fixed height of the check button."
	^switch bounds height * 3.! !

!PrefabCheckButton methodsFor: 'private' stamp: 'cr 7/24/1999 18:50'!
labelOrigin
	"Return the point to be the origin of the label."
	^(self innerBounds origin + (switch bounds width * 3)) x @ self innerBounds origin y.! !

!PrefabCheckButton methodsFor: 'private' stamp: 'cr 7/24/1999 23:57'!
minimumWidth
	"Return the smallest size to which the button can be sized."
	^switch bounds width * 4.! !

!PrefabCheckButton methodsFor: 'private' stamp: 'cr 7/24/1999 18:52'!
switchPosition
	"Return the position to be occupied by actual button part."
	^self bounds origin + switch extent.! !

!PrefabCheckButton methodsFor: 'change reporting' stamp: 'cr 7/24/1999 19:11'!
layoutChanged

	switch position: self switchPosition.
	label bounds: (self labelOrigin corner: self innerBounds corner).

	super layoutChanged.! !

!PrefabCheckButton methodsFor: 'construction' stamp: 'cr 1/8/2000 01:48'!
attributeList
	"Return a collection of pairs of (attributeName: value) that can be used to reconstruct
	 this prefab completely."
	^super attributeList, {label labelAttributeConstructor}
		add: {#contentOrientation:. self contentOrientation};
		yourself.! !


!PrefabEdit commentStamp: 'cr 2/27/2000 20:01' prior: 0!
This class implements a simple text editor.  It's not a *good* text editor, mind you, but it
does edit text and lets you scroll around a bit and it's easy to hook into your code.

(If you happen to fix any of its many deficiencies, send me a change set.).

!

!PrefabEdit reorganize!
('initialization' initialize)
('API' extent: foregroundColor foregroundColor: isReadOnly isReadOnly:)
('API-Behaviour' fractionalPosition fractionalPosition: scrollPosition scrollPosition: text text: vScrollBar: visibleRatio)
('events' handlesMouseOver: mouseEnter: mouseLeave: scrollAfterSelection:changedFrom:)
('private' lineHeight scrollTo: updateSlider visibleLines)
!


!PrefabEdit methodsFor: 'initialization' stamp: 'cr 2/27/2000 02:09'!
initialize
	super initialize.

	scrollPosition := 1.

	self borderWidth: 2;
		borderColor: #inset.

	textTransform := TransformMorph new 
						color: Color transparent;
						bounds: self innerBounds;
						yourself.

	self addMorph: textTransform.

	text := HookedTextMorph new
			contentsWrapped: 'edit me';
			hookTarget: self;
			position: 0@0;
			extent: self innerBounds extent.

	textTransform addMorph: text.

	self extent: 	80@80.

	! !

!PrefabEdit methodsFor: 'API' stamp: 'cr 2/7/2000 23:20'!
extent: aPoint
	super extent: aPoint.
	textTransform extent: self innerBounds extent.
	text width: self innerBounds width.
! !

!PrefabEdit methodsFor: 'API' stamp: 'cr 2/8/2000 18:34'!
foregroundColor
	^text color! !

!PrefabEdit methodsFor: 'API' stamp: 'cr 2/8/2000 18:34'!
foregroundColor: aColor
	text color: aColor.! !

!PrefabEdit methodsFor: 'API' stamp: 'cr 2/19/2000 23:00'!
isReadOnly
	^text dropKeys! !

!PrefabEdit methodsFor: 'API' stamp: 'cr 2/19/2000 23:01'!
isReadOnly: aBoolean
	"Set read-only-ness of this editor."
	text dropKeys: aBoolean.! !

!PrefabEdit methodsFor: 'API-Behaviour' stamp: 'cr 2/8/2000 22:01'!
fractionalPosition
	"Return a number between 0 and 1 indicating the position of the
	 lines currently displayed relative to the entire editor.  A value
	 of 0.0 means the first line is visible and 1.0 means the last line is
	 visible. (If both are visible, the result may be somewhere in between."


	self visibleRatio >= 1
		ifTrue: [^0.0].

	^ (self scrollPosition + 1) asFloat / (text paragraph numberOfLines - self visibleLines)! !

!PrefabEdit methodsFor: 'API-Behaviour' stamp: 'cr 2/8/2000 19:28'!
fractionalPosition: aNumber
	"Set scroll position as a number between 0 and 1 indicating the position of the
	 list entries currently displayed relative to the entire list.  A value
	 of 0.0 means the first item is visible and 1.0 means the last item is
	 visible."

	self scrollPosition: ((aNumber min: 1 max: 0) asFloat 
							* (text paragraph numberOfLines - self visibleLines)) rounded + 1.
	 
! !

!PrefabEdit methodsFor: 'API-Behaviour' stamp: 'cr 2/8/2000 19:19'!
scrollPosition
	"Return position to which the editor is scrolled."

	^scrollPosition! !

!PrefabEdit methodsFor: 'API-Behaviour' stamp: 'cr 2/9/2000 23:48'!
scrollPosition: index
	"Make 'index' the index of the first visible element."

	index = scrollPosition
		ifTrue: [^self].

	self scrollTo: index.
	scrollPosition := index.

	self updateSlider.! !

!PrefabEdit methodsFor: 'API-Behaviour' stamp: 'cr 2/7/2000 23:09'!
text
	^text contents asString.! !

!PrefabEdit methodsFor: 'API-Behaviour' stamp: 'cr 2/26/2000 22:22'!
text: aTextOrString
	text contentsWrapped: aTextOrString asString.
	self updateSlider! !

!PrefabEdit methodsFor: 'API-Behaviour' stamp: 'cr 2/8/2000 19:41'!
vScrollBar: aPrefabScrollBar	
	"Make aPrefabScrollBar the scrollbar that controls this listbox's vertical
	 scroll position, safely removing the current scrollbar (if there is one).  If
	 aPrefabScrollBar is nil, just remove the current scrollbar."

	vScrollBar ifNotNil: [
		vScrollBar target: nil;
			action: nil.
		vScrollBar := nil.
	].

	vScrollBar := aPrefabScrollBar.

	aPrefabScrollBar ifNotNil: [
		aPrefabScrollBar target: self;
			action: #fractionalPosition:.
		self updateSlider.
	].! !

!PrefabEdit methodsFor: 'API-Behaviour' stamp: 'cr 2/8/2000 19:26'!
visibleRatio
	| ratio |
	"Return a number between 0 and 1 that indicates what fraction of the lines 
	 can be displayed in the current window."

	ratio := self visibleLines / text paragraph numberOfLines.
	ratio > 1
		ifTrue: [ratio := 1].

	^ratio! !

!PrefabEdit methodsFor: 'events' stamp: 'cr 2/27/2000 02:08'!
handlesMouseOver: evt
	^true.! !

!PrefabEdit methodsFor: 'events' stamp: 'cr 2/27/2000 02:08'!
mouseEnter: event
	"Restore the selection."

	super mouseEnter: event.

	selection ifNotNil: [
		text handleEdit: [
			text editor selectInterval: selection;
				setEmphasisHere
		]
	].
	event hand newKeyboardFocus: text
! !

!PrefabEdit methodsFor: 'events' stamp: 'cr 2/27/2000 02:08'!
mouseLeave: event
	"Snag the selection before the focus goes away."

	text ifNotNil: [selection := text editor selectionInterval].
	super mouseLeave: event.
	event hand newKeyboardFocus: nil.
! !

!PrefabEdit methodsFor: 'events' stamp: 'cr 2/19/2000 22:40'!
scrollAfterSelection: afterSel changedFrom: beforeSel
	"After a keystroke, scroll the cursor back into view if necessary."
	| cursorIndex line sp |

	"Determine cursor index."
	afterSel first = afterSel last
		ifTrue: [cursorIndex := afterSel first]
		ifFalse: [
			afterSel first ~= beforeSel first
				ifTrue: [cursorIndex := afterSel last]
				ifFalse: [cursorIndex := afterSel last].
		].


	line := text paragraph lineIndexOfCharacterIndex: cursorIndex + 1.
	sp := self scrollPosition.

	line < sp
		ifTrue: [^self scrollPosition: line].

	line >= (sp + self visibleLines - 1)
		ifTrue: [^self scrollPosition: line - self visibleLines + 1].


! !

!PrefabEdit methodsFor: 'private' stamp: 'cr 2/8/2000 18:53'!
lineHeight
	^text defaultLineHeight! !

!PrefabEdit methodsFor: 'private' stamp: 'cr 2/8/2000 21:45'!
scrollTo: index
	"Pvt--Scroll to line 'index'."
	textTransform offset: 0@((index - 1) * self lineHeight).! !

!PrefabEdit methodsFor: 'private' stamp: 'cr 2/8/2000 19:41'!
updateSlider
	"Position and size the slider of the attached vertical scroll bar (if it exists)
	 to reflect the current position and viewable ratio."
	vScrollBar ifNotNil: [
		vScrollBar ratio: self visibleRatio;
			fractionalPositionQuiet: self fractionalPosition;
			stepSize: 1.0/text paragraph numberOfLines
	].! !

!PrefabEdit methodsFor: 'private' stamp: 'cr 2/8/2000 18:53'!
visibleLines
	"Return number of lines displayable at current size."
	^self innerBounds height // self lineHeight.! !


!PrefabEntry commentStamp: 'cr 2/27/2000 20:07' prior: 0!
This class implements a minimal 1-line text entry widget, suitable for editing a small amount
of text such as a file name or user-id.  It also allows you to associate an action with
the return key.

Its height is fixed to one line of text.

Note: Due to HookedTextMorph not being particularly good, there's a (theoretically very large)
upper limit on how many characters can be put in such a widget before the text becomes
invisible due to the HookedTextMorph's attempts at wrapping the line.  Don't try to put a copy
of War And Peace in one of these.
!

!PrefabEntry reorganize!
('initialization' initialize)
('API' extent: foregroundColor foregroundColor: text text:)
('API-Actions' actionReturnPressed: argsReturnPressed: targetReturnPressed:)
('events' returnHit: scrollAfterSelection:changedFrom:)
('private' lineHeight)
!


!PrefabEntry methodsFor: 'initialization' stamp: 'cr 3/8/2000 21:35'!
initialize
	super initialize.

	returnResponse := PrefabResponse new.

	self borderWidth: 2;
		borderColor: #inset.

	textTransform := TransformMorph new 
						color: Color transparent;
						bounds: self innerBounds;
						yourself.
	self addMorph: textTransform.

	text := HookedTextMorph new
			contentsWrapped: 'edit me';
			hookTarget: self;
			position: 0@0;
			width: 99999;
			addHookFor: Character cr withMessage: #returnHit:.

	textTransform addMorph: text.

	self extent: 80 @ 1.		"Height is ignored."
	
	"Set text to fill its container."
"	((text container isKindOf: TextContainer) and: [text container fillsOwner not])
		ifFalse: [text fillingOnOff].
"


	! !

!PrefabEntry methodsFor: 'API' stamp: 'cr 2/8/2000 18:54'!
extent: aPoint
	super extent: aPoint x @ (self lineHeight + (self borderWidth * 2)).
	textTransform extent: self innerBounds extent.
	owner ifNotNil: [text height: text defaultLineHeight].
! !

!PrefabEntry methodsFor: 'API' stamp: 'cr 2/7/2000 23:32'!
foregroundColor
	^text color! !

!PrefabEntry methodsFor: 'API' stamp: 'cr 2/7/2000 23:31'!
foregroundColor: aColor
	text color: aColor.! !

!PrefabEntry methodsFor: 'API' stamp: 'cr 8/20/1999 23:14'!
text
	^text contents asString.! !

!PrefabEntry methodsFor: 'API' stamp: 'cr 2/19/2000 21:41'!
text: aTextOrString
	text contentsWrapped: aTextOrString asString! !

!PrefabEntry methodsFor: 'API-Actions' stamp: 'cr 1/23/2000 19:40'!
actionReturnPressed: aBlockOrSymbol
	"Action to occur when return is pressed."
	returnResponse action: aBlockOrSymbol.! !

!PrefabEntry methodsFor: 'API-Actions' stamp: 'cr 1/23/2000 19:44'!
argsReturnPressed: anArray
	"Array of extra arguments to pass to the response invoked when return is pressed."
	returnResponse args: anArray.! !

!PrefabEntry methodsFor: 'API-Actions' stamp: 'cr 1/23/2000 19:46'!
targetReturnPressed: anObject
	"The target to which to send the message assigned to actionReturnPressed (if it's a symbol
	 and not a block) when return is pressed."
	returnResponse target: anObject.! !

!PrefabEntry methodsFor: 'events' stamp: 'cr 1/25/2000 22:06'!
returnHit: char
	| r |
	"The message the HookedTextMorph sends when return is hit."

	r := returnResponse invoke.

	"For the sake of tolerance, we assume a non-boolean return value is false."
	(r isKindOf: Boolean	)
		ifTrue: [^r]
		ifFalse: [^false].
	
! !

!PrefabEntry methodsFor: 'events' stamp: 'cr 3/8/2000 21:23'!
scrollAfterSelection: afterSel changedFrom: beforeSel
	| cursorIndex cb tib shiftVal |
	"Offset the text morph so that the curser is always visible."

	"Determine cursor index."
	afterSel first = afterSel last
		ifTrue: [cursorIndex := afterSel first]
		ifFalse: [
			afterSel first ~= beforeSel first
				ifTrue: [cursorIndex := afterSel last]
				ifFalse: [cursorIndex := afterSel last].
		].

	cursorIndex = 0
		ifTrue: [
			textTransform offset: 0@0.
			^self.
		].

	tib := textTransform innerBounds.
	cb := (text paragraph characterBlockForIndex: cursorIndex) translateBy: tib origin.

	(tib containsRect: cb)
		ifFalse: [
			cb left < tib left
				ifTrue: [shiftVal := cb left - tib left]
				ifFalse: [shiftVal := cb right - tib right].

			textTransform offset: shiftVal@0.
		].






! !

!PrefabEntry methodsFor: 'private' stamp: 'cr 2/13/2000 18:44'!
lineHeight
	^text defaultLineHeight! !


!PrefabFrame commentStamp: 'cr 2/27/2000 20:12' prior: 0!
This class implements a rectangular region with an optional decorative border.  It may be used
to hold other Prefab widgets, although they continue to be managed by the instance's Manager.

PrefabFrames have two uses: 1) they look pretty and 2) they can be used to group PrefabRadioButtons
so that you can put multiple sets of them on one Manager.

The border may be raised, sunken or flush.


!

!PrefabFrame reorganize!
('initialization' initialize)
('API' style style:)
('construction' attributeList)
('dragging/dropping' acceptDroppingMorph:event: allowSubmorphExtraction privateRemoveMorph: wantsDroppedMorph:event:)
('menu' addCustomMenuItems:hand: setStyle)
('placement' hollowRegion)
!


!PrefabFrame methodsFor: 'initialization' stamp: 'cr 7/13/1999 23:08'!
initialize
	super initialize.

	self borderWidth: Prefab defaultFrameBorderWidth.
	self borderColor: #inset.
	self extent: 103@32.! !

!PrefabFrame methodsFor: 'API' stamp: 'cr 7/14/1999 23:40'!
style
	"Return the look of the frame."

	| bc |
	bc := self borderColor.

	bc class = Color
		ifTrue: [^#flush]
		ifFalse: [^bc].
! !

!PrefabFrame methodsFor: 'API' stamp: 'cr 7/14/1999 23:40'!
style: aSymbol
	"Set the look of the frame."

	"Paranoia"
	(#(inset raised flush) includes: aSymbol)
		ifFalse: [self error: 'invalid style, ', aSymbol printString].

	aSymbol = #flush
		ifTrue: [self borderColor: self color]
		ifFalse: [self borderColor: aSymbol].
! !

!PrefabFrame methodsFor: 'construction' stamp: 'cr 1/28/2000 22:48'!
attributeList
	"Return a collection of pairs of (attributeName: value) that can be used to reconstruct
	 this prefab completely."
	^super attributeList
		add: {#style:. self style};
		yourself.! !

!PrefabFrame methodsFor: 'dragging/dropping' stamp: 'cr 2/24/2000 22:41'!
acceptDroppingMorph: aMorph event: evt
	"Allow the user to add submorphs just by dropping them on this morph."
	(self manager isKindOf: PrefabConstruction)
		ifTrue: [self manager addClient: aMorph].
! !

!PrefabFrame methodsFor: 'dragging/dropping' stamp: 'cr 1/11/2000 00:10'!
allowSubmorphExtraction
	
	^self manager class = PrefabConstruction! !

!PrefabFrame methodsFor: 'dragging/dropping' stamp: 'cr 2/23/2000 21:41'!
privateRemoveMorph: aMorph
	"If aMorph is a prefab, notify the resizer of the change."

	(aMorph isPrefab and: [self manager notNil])
		ifTrue: [self manager resizer removeClient: aMorph].

	super privateRemoveMorph: aMorph.! !

!PrefabFrame methodsFor: 'dragging/dropping' stamp: 'cr 2/24/2000 22:42'!
wantsDroppedMorph: aMorph event: evt
	"Return true if the receiver wishes to accept the given morph, which is being dropped by a hand in response to the given event."

	^ self manager notNil and: [self manager wantsDroppedMorph: aMorph event: evt].! !

!PrefabFrame methodsFor: 'menu' stamp: 'cr 2/24/2000 22:20'!
addCustomMenuItems: aCustomMenu hand: aHandMorph
	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	
	aCustomMenu add: 'Set border style' target: self action: #setStyle.! !

!PrefabFrame methodsFor: 'menu' stamp: 'cr 2/24/2000 22:22'!
setStyle
	"Pick a border style."
	| styles index |
	styles := #(raised inset flushed).

	index := (PopUpMenu labels: 'raised\inset\flush' withCRs)
				startUpWithCaption: 'Pick a border style'.

	self style: (styles at: index).! !

!PrefabFrame methodsFor: 'placement' stamp: 'cr 7/14/1999 22:59'!
hollowRegion
	^self innerBounds! !


!PrefabLabel commentStamp: 'cr 3/8/2000 22:37' prior: 0!
This class implements a label widget.  Labels are non-interactive widgets that display
either text or a picture.  If text, a string or Text may be used as input (but style information
is currently ignored).  Images may be given as a form, the name of an image file or
an entry in the Prefab image library.!

!PrefabLabel reorganize!
('initialization' initialize)
('API' contentOrientation contentOrientation: foregroundColor: idealExtent image: text text:)
('attribute-list creation' labelAttributeConstructor)
('change reporting' layoutChanged)
('construction' attributeList)
('menu' addCustomMenuItems:hand: setImage setImageFile setOrientation setText)
('private' labelMorph: submorphRectangle)
!


!PrefabLabel methodsFor: 'initialization' stamp: 'cr 7/3/1999 23:01'!
initialize
	super initialize.
	orientation := #centered.

	self text: 'A Label'.! !

!PrefabLabel methodsFor: 'API' stamp: 'cr 1/8/2000 01:47'!
contentOrientation
	"Get position of the displayable within the label.  Options are #left, #right and #center
	 and they determine where (horizontally) the image or text is placed inside the bounds
	 of the label (or button) iff there is extra space."
	^orientation
! !

!PrefabLabel methodsFor: 'API' stamp: 'cr 1/8/2000 01:49'!
contentOrientation: anOrientation
	"Set position of the displayable within the label.  Options are #left, #right and #center
	 and they determine where (horizontally) the image or text is placed inside the bounds
	 of the label (or button) iff there is extra space."

	(#(left right centered) includes: anOrientation)
		ifFalse: [self error: 'invalid orientation: ', orientation printString].

	orientation := anOrientation.
	self layoutChanged.! !

!PrefabLabel methodsFor: 'API' stamp: 'cr 12/20/1999 22:43'!
foregroundColor: aColor
	"Set foreground color"
	super foregroundColor: aColor.
	
	(labelMorph isKindOf: StringMorph)
		ifTrue: [labelMorph color: aColor].! !

!PrefabLabel methodsFor: 'API' stamp: 'cr 7/24/1999 19:37'!
idealExtent
	"Return the extent that would best display the contents without clipping or excess
	 empty space."
	
	labelMorphMaxSize ifNil: [^ self borderWidth + 10@10].

	^labelMorphMaxSize + self borderWidth.! !

!PrefabLabel methodsFor: 'API' stamp: 'cr 1/19/2000 00:27'!
image: img
	"Set the label to display the image 'img'.  If img is a symbol, look it up in the
	 image library.  If it's a string, assume it's a filename and try to load it.  If it's
	 a form, just copy it."
	| form |

	(img isKindOf: Symbol)
		ifTrue: [
			form := Prefab formNamed: img.
			imageID := img.
		].

	img class = String
		ifTrue: [
			form := ImageReadWriter formFromFileNamed: img.
			imageID := img.
		].		

	(img isKindOf: Form)
		ifTrue: [
			form := img.
			imageID := nil.
		].

	form ifNil: [self error: 'Argument must be one of Symbol, String or Form'.].

	self labelMorph: (ClippedImageMorph new form: form).
! !

!PrefabLabel methodsFor: 'API' stamp: 'cr 12/20/1999 22:42'!
text
	"Return the text of the label.  If there is no text (say there's a picture instead), return nil."

	(labelMorph isKindOf: StringMorph)
		ifTrue: [^labelMorph contents].

	^nil.! !

!PrefabLabel methodsFor: 'API' stamp: 'cr 2/19/2000 22:13'!
text: aTextOrString
	"Set the label's contents to 'aTextOrString'."
	self labelMorph: (StringMorph new contents: aTextOrString asString;
					  color: self foregroundColor).
	imageID := nil.! !

!PrefabLabel methodsFor: 'attribute-list creation' stamp: 'cr 10/31/1999 14:32'!
labelAttributeConstructor
	"Return an array containing a message name and value that can be used to recreate my
	 text or image part.  If no such thing can be found, return an empty array."

	imageID ifNotNil: [
		^{#image:. imageID}.
	].

	self submorphsDo: [ :s |
		s class = ClippedImageMorph
			ifTrue: [^{#image:. s form}].

		s class = StringMorph
			ifTrue: [^{#text:. s contents}].
	].

	^#().! !

!PrefabLabel methodsFor: 'change reporting' stamp: 'cr 7/4/1999 23:28'!
layoutChanged
	labelMorph ifNotNil: [
			labelMorph bounds: self submorphRectangle.
	].

	super layoutChanged.
! !

!PrefabLabel methodsFor: 'construction' stamp: 'cr 1/8/2000 01:48'!
attributeList
	"Return a collection of pairs of (attributeName: value) that can be used to reconstruct
	 this prefab completely."
	^super attributeList, {self labelAttributeConstructor}
		add: {#contentOrientation:. self contentOrientation};
		yourself.! !

!PrefabLabel methodsFor: 'menu' stamp: 'cr 1/8/2000 01:53'!
addCustomMenuItems: aCustomMenu hand: aHandMorph
	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	
	aCustomMenu add: 'Set text' target: self action: #setText;
		add: 'Set content orientation' target: self action: #setOrientation;
		add: 'Set image from image dictionary' target: self action: #setImage;
		add: 'Set image from file' target: self action: #setImageFile.! !

!PrefabLabel methodsFor: 'menu' stamp: 'cr 7/11/1999 21:13'!
setImage
	"Set the label's image."
	| newImage |
	newImage := FillInTheBlank request: 'Enter new label image (as a dictionary entry)'.
	newImage isEmpty
		ifFalse: [self image: newImage asSymbol].
			! !

!PrefabLabel methodsFor: 'menu' stamp: 'cr 10/24/1999 20:43'!
setImageFile
	"Set the label's image to the file in the given path."
	| newImage |
	newImage := FillInTheBlank request: 'Enter new image file name'.
	newImage isEmpty
		ifFalse: [self image: newImage].
			! !

!PrefabLabel methodsFor: 'menu' stamp: 'cr 1/8/2000 01:51'!
setOrientation
	
	| orientations index |
	orientations := #(left right centered).

	index := (PopUpMenu labels: 'left\right\centered' withCRs)
				startUpWithCaption: 'Pick an orientation'.

	self contentOrientation: (orientations at: index).! !

!PrefabLabel methodsFor: 'menu' stamp: 'cr 7/11/1999 21:12'!
setText
	"Set the label's text."
	| newText |
	newText := FillInTheBlank request: 'Enter new label text'.
	newText isEmpty
		ifFalse: [self text: newText].
			! !

!PrefabLabel methodsFor: 'private' stamp: 'cr 7/4/1999 00:00'!
labelMorph: aMorph
	
	labelMorph ifNotNil: [
		labelMorph delete.
	].

	labelMorph := aMorph.
	labelMorphMaxSize := aMorph extent.
	"labelMorph position: self center - (labelMorph extent // 2)."
	self addMorph: aMorph.! !

!PrefabLabel methodsFor: 'private' stamp: 'cr 7/4/1999 17:39'!
submorphRectangle
	"Return the rectangle containing the label part (i.e. a StringMorph or ClippedImage). This
	must be inside the innerBounds, no bigger than labelMorphMaxSize in either direction and
	positioned according to the value of orientation if possibility.  Currently, only left, right
	and centered are supported."

	| labelRect ib |

	ib := self innerBounds.

	labelRect := Rectangle center: ib center extent: labelMorphMaxSize.
	
	orientation = #left
		ifTrue: [
			labelRect := labelRect translateBy: (ib left - labelRect left) @ 0.
		].

	orientation = #right
		ifTrue: [
			labelRect := labelRect translateBy: (ib right - labelRect right) @ 0.
		].


	"If neither of these is true, we assume orientation #centered, the default."

	"Clip along the horizontal if necessary.  If this happens, we revert to left-justification."
	labelRect width > ib width
		ifTrue: [
			labelRect := Rectangle origin: ib origin x @ labelRect origin y
							extent: (ib width)@labelRect height
		].


	"Now do the vertical."
	labelRect height > ib height
		ifTrue: [
			labelRect := Rectangle origin: labelRect origin x @ (ib origin y)
							extent: (labelRect withHeight: ib height) extent.
		].
	
	
	^labelRect.
! !


!PrefabButton commentStamp: 'cr 2/27/2000 18:59' prior: 0!
A prefab button.  It may contain a textual label or a bitmap just like a PrefabLabel.

Behaviour when pressed is determined by methods #action:, #args: and #target:.  See the
comment for PrefabResponse for an explanation of how this works.!

!PrefabButton reorganize!
('initialization' initialize)
('API' action: args: target:)
('private')
('event handling' handlesMouseDown: mouseDown: mouseMove: mouseUp:)
('construction' attributeList)
!


!PrefabButton methodsFor: 'initialization' stamp: 'cr 11/28/1999 00:56'!
initialize
	super initialize.

	response := PrefabResponse new.

	self borderWidth: Prefab defaultButtonBorderWidth.
	self borderColor: #raised.
	clickedIn := false.
	self text: 'A Button'.
	self extent: 103@32.! !

!PrefabButton methodsFor: 'API' stamp: 'cr 12/6/1999 00:21'!
action: aBlockOrSymbol
	"Set the action to 1) a block to evaluate when the button is pressed or 2) a message to send
	 to a specified target."
	response action: aBlockOrSymbol! !

!PrefabButton methodsFor: 'API' stamp: 'cr 11/28/1999 00:56'!
args: anArray
	"Set args to array of arguments to be used as parameters by action."
	response args: anArray! !

!PrefabButton methodsFor: 'API' stamp: 'cr 11/28/1999 02:32'!
target: anObject
	"The object that gets the message when the button is pressed."
	response target: anObject! !

!PrefabButton methodsFor: 'event handling' stamp: 'cr 6/26/1999 23:07'!
handlesMouseDown: evt
	^true.
! !

!PrefabButton methodsFor: 'event handling' stamp: 'cr 6/26/1999 23:18'!
mouseDown: evt

	clickedIn := true.
	self borderColor: #inset.! !

!PrefabButton methodsFor: 'event handling' stamp: 'cr 7/4/1999 00:30'!
mouseMove: evt
	"If the pointer was moved out of the button's perimeter without the blue button being
	 released, unpress the button without performing the action."

	(self containsPoint: evt cursorPoint)
		ifFalse: [
			clickedIn := false.
			self borderColor: #raised.
		].


! !

!PrefabButton methodsFor: 'event handling' stamp: 'cr 11/28/1999 02:22'!
mouseUp: evt

	clickedIn
		ifFalse: [^self].

	clickedIn := false.
	self borderColor: #raised.

	response invoke.! !

!PrefabButton methodsFor: 'construction' stamp: 'cr 1/8/2000 01:31'!
attributeList
	"Return a collection of pairs of (attributeName: value) that can be used to reconstruct
	 this prefab completely."

	^super attributeList.

	"This is tricky, since action-related attributes are too dependent on non-GUI elements.
	 For the moment, I'm going to leave this alone."
! !


!PrefabListBox commentStamp: 'cr 2/27/2000 21:46' prior: 0!
This class implements a standard list-box widget.

In addition to providing a scrollable list, it allows you to associate an action with an item being
selected and to choose between allowing and disallowing multiple selections.

Entries in the list box must be a two-element array containing a string as its first element and an
arbitrary object as its second.  (You can get away with just giving it a string, in which case it will
treat it as an array containing two references to the same string.)  The string is what is displayed
in the associated listbox slot.  When accessing the listbox with the #at: method, this pair is what
is returned.  However, actions set with #actionClicked: receive only the second object as an argument.

PrefabListBoxes implement a very, very tiny subset of the interface to OrderedCollection as a means of 
adding or removing elements.  

A PrefabScrollBar can easily be plugged into it via the #vScrollBar: method.  !

!PrefabListBox reorganize!
('initialization' initialize)
('API-Appearance' elementHeight elementHeight: extent: foregroundColor: scrollPosition scrollPosition: selectColor selectColor: selectForeground selectForeground:)
('API-Selection and Position' fractionalPosition fractionalPosition: selectionMode selectionMode: vScrollBar: visibleRatio)
('API-Actions' actionClicked: argsClicked: targetClicked:)
('API-Contents' addLast: at: at:put: size)
('private' deSelectLabel: rowFor: scrollTo: selectLabel: updateSlider visibleLines)
('construction' attributeList)
('event handling' paneClickedEvent:onLabel:)
('misc' test)
!


!PrefabListBox methodsFor: 'initialization' stamp: 'cr 2/27/2000 20:41'!
initialize
	super initialize.

	items := OrderedCollection new.
	indices := IdentityDictionary new.
	selection := Set new.
	selectionMode := #single.
	selectColor := Prefab defaultListBoxSelectionColor.
	selectForeground := Prefab defaultListBoxSelectionForeground.
	scrollPosition := 1.
	elementHeight := Prefab listBoxElementHeight.
	selectResponse := PrefabResponse new.
	super extent: 175@(15*elementHeight).

	self addMorph: (transform := TransformMorph new
						color: Color transparent;
						bounds: self innerBounds;
						yourself).

	self borderWidth: 2;
		borderColor: #inset.! !

!PrefabListBox methodsFor: 'API-Appearance' stamp: 'cr 12/20/1999 22:33'!
elementHeight
	^elementHeight! !

!PrefabListBox methodsFor: 'API-Appearance' stamp: 'cr 1/4/2000 23:26'!
elementHeight: anInteger
	| elem |
	"Set the height of each individual list item."

	elementHeight = anInteger
		ifTrue: [^self].

	elementHeight := anInteger.
	
	(1 to: items size) do: [ :n |
		elem := (items at: n) first.
		elem position: elem origin x @ (elementHeight * (n - 1)).
	].
	self updateSlider.! !

!PrefabListBox methodsFor: 'API-Appearance' stamp: 'cr 1/4/2000 23:20'!
extent: aPoint

	super extent: aPoint.
	transform bounds: self innerBounds.
	self scrollTo: scrollPosition.
	self updateSlider.! !

!PrefabListBox methodsFor: 'API-Appearance' stamp: 'cr 12/20/1999 22:55'!
foregroundColor: aColor
	"Set foreground color and update submorphs."

	super foregroundColor: aColor.
	items do: [ :i |
		(selection includes: i)
			ifFalse: [i first foregroundColor: aColor].
	]! !

!PrefabListBox methodsFor: 'API-Appearance' stamp: 'cr 12/21/1999 00:40'!
scrollPosition
	"Return position to which the listbox is scrolled."

	^scrollPosition! !

!PrefabListBox methodsFor: 'API-Appearance' stamp: 'cr 1/4/2000 22:55'!
scrollPosition: index
	"Make 'index' the index of the first visible element."

	index = scrollPosition
		ifTrue: [^self].

	self scrollTo: index.
	scrollPosition := index.
! !

!PrefabListBox methodsFor: 'API-Appearance' stamp: 'cr 12/20/1999 23:04'!
selectColor
	^selectColor! !

!PrefabListBox methodsFor: 'API-Appearance' stamp: 'cr 12/20/1999 23:04'!
selectColor: aColor
	"Set background color of selected elements."
	selectColor := aColor.
	selection do: [ :i |
		i color: aColor
	].! !

!PrefabListBox methodsFor: 'API-Appearance' stamp: 'cr 12/20/1999 22:59'!
selectForeground
	^selectForeground! !

!PrefabListBox methodsFor: 'API-Appearance' stamp: 'cr 12/20/1999 23:01'!
selectForeground: aColor
	"Set foreground color of selected elements."
	selectForeground := aColor.
	selection do: [ :i |
		i foregroundColor: aColor
	].! !

!PrefabListBox methodsFor: 'API-Selection and Position' stamp: 'cr 2/8/2000 21:57'!
fractionalPosition
	"Return a number between 0 and 1 indicating the position of the
	 list entries currently displayed relative to the entire list.  A value
	 of 0.0 means the first item is visible and 1.0 means the last item is
	 visible. (If both are visible, the result may be somewhere in between."


	self visibleRatio >= 1
		ifTrue: [^0.0].

	^ (self scrollPosition - 1) asFloat / (items size - self visibleLines)! !

!PrefabListBox methodsFor: 'API-Selection and Position' stamp: 'cr 12/29/1999 17:09'!
fractionalPosition: aNumber
	"Set scroll position as a number between 0 and 1 indicating the position of the
	 list entries currently displayed relative to the entire list.  A value
	 of 0.0 means the first item is visible and 1.0 means the last item is
	 visible."

	self scrollPosition: ((aNumber min: 1 max: 0) asFloat 
							* (items size - self visibleLines)) rounded + 1.
	 
! !

!PrefabListBox methodsFor: 'API-Selection and Position' stamp: 'cr 1/4/2000 23:37'!
selectionMode
	"Return selection mode. One of #single (only allow one item to be selected at any one time) or
	 #multiple (allow shift+click to select multiple items)."
	^selectionMode.! !

!PrefabListBox methodsFor: 'API-Selection and Position' stamp: 'cr 12/20/1999 22:17'!
selectionMode: aSymbol
	"Set selection mode. One of #single (only allow one item to be selected at any one time) or
	 #multiple (allow shift+click to select multiple items)."
	| s |

	"Protect from invalid modes."
	(#(single multiple) includes: aSymbol)
		ifFalse: [self error: 'invalid selection mode, #', aSymbol asString].


	(aSymbol = #single and: [selectionMode = #multiple and: [selection size > 1]])
		ifTrue: [
			s := selection anyOne.
			selection do: [ :i | i ~= s ifTrue: [self deSelectLabel: i]].
			selection := Set with: s.
		].
	selectionMode := aSymbol! !

!PrefabListBox methodsFor: 'API-Selection and Position' stamp: 'cr 1/3/2000 00:38'!
vScrollBar: aPrefabScrollBar	
	"Make aPrefabScrollBar the scrollbar that controls this listbox's vertical
	 scroll position, safely removing the current scrollbar (if there is one).  If
	 aPrefabScrollBar is nil, just remove the current scrollbar."

	vScrollBar ifNotNil: [
		vScrollBar target: nil;
			action: nil.
		vScrollBar := nil.
	].

	vScrollBar := aPrefabScrollBar.

	aPrefabScrollBar ifNotNil: [
		aPrefabScrollBar target: self;
			action: #fractionalPosition:.
		self updateSlider.
	].! !

!PrefabListBox methodsFor: 'API-Selection and Position' stamp: 'cr 12/29/1999 16:31'!
visibleRatio
	| ratio |
	"Return a number between 0 and 1 that indicates what fraction of the contents 
	 can be displayed in the current window."

	ratio := self visibleLines / items size.
	ratio > 1
		ifTrue: [ratio := 1].

	^ratio! !

!PrefabListBox methodsFor: 'API-Actions' stamp: 'cr 2/27/2000 20:43'!
actionClicked: aStringOrBlock
	"Action to perform when an item is selected (or possibly de-selected)."
	selectResponse action: aStringOrBlock.! !

!PrefabListBox methodsFor: 'API-Actions' stamp: 'cr 2/27/2000 20:51'!
argsClicked: anArray
	"Extra args passed on with response."
	selectResponse args: anArray.! !

!PrefabListBox methodsFor: 'API-Actions' stamp: 'cr 2/27/2000 20:43'!
targetClicked: anObject
	"Target for select action."
	selectResponse target: anObject.! !

!PrefabListBox methodsFor: 'API-Contents' stamp: 'cr 1/3/2000 00:39'!
addLast: aPairOrString
	"Append an item with label identical to value.  Convenience method."
	items addLast: nil.
	self at: items size put: aPairOrString.
	self updateSlider.
	^aPairOrString.! !

!PrefabListBox methodsFor: 'API-Contents' stamp: 'cr 1/4/2000 23:28'!
at: index
	"Return the pair (Array with label string and associated object) at index."
	| pair |
	pair := items at: index.
	^Array with: pair first text with: pair second.! !

!PrefabListBox methodsFor: 'API-Contents' stamp: 'cr 1/4/2000 22:50'!
at: index put: pairOrString
	"Put pairOrString at index and update the display to reflect this.  A pair is a two-element
	 Array (or array-like thing) containing a string and another object.  The string is displayed
	 in the list box while the second object is passed on to various hooks and things."
	| pair entry oldItem |

	"Create a pair if pairOrString is a string."
	(pairOrString isKindOf: String)
		ifTrue: [pair := Array with: pairOrString with: pairOrString]
		ifFalse: [pair := pairOrString].
	
	"Remove the old item, if it existed."
	oldItem := items at: index.
	oldItem
		ifNotNil: [
			oldItem first destroy.
			indices removeKey: oldItem first.
		].

	"Create the row and install it."
	entry := self rowFor: pair first.
	entry position: 0@(index * self elementHeight).
	transform addMorph: entry.

	items at: index put: {entry. pair second}.
	indices at: entry put: index.

	^pairOrString.! !

!PrefabListBox methodsFor: 'API-Contents' stamp: 'cr 12/29/1999 15:27'!
size
	"Return the number of elements in the list box."
	^items size! !

!PrefabListBox methodsFor: 'private' stamp: 'cr 12/20/1999 22:46'!
deSelectLabel: label
	"Pvt-Mark label as not being selected.  Doesn't effect internal selection set."
	label color: self color;
		foregroundColor: self foregroundColor.! !

!PrefabListBox methodsFor: 'private' stamp: 'cr 1/19/2000 00:33'!
rowFor: aString
	| label |
	"Pvt--return a label for 'aString'"

	label := PrefabLabel new
				text: ' ', aString;
				width: 999999;		"take advantage of the transform's clipping"
				height: elementHeight;
				contentOrientation: #left;
				color: self color;
				foregroundColor: self foregroundColor;
				borderWidth: 0;
				yourself.

	label on: #mouseDown send: #paneClickedEvent:onLabel: to: self.

	^label.! !

!PrefabListBox methodsFor: 'private' stamp: 'cr 1/4/2000 23:07'!
scrollTo: index
	"Pvt--update submorphs to display self scrolled to index."
	transform offset: 0@(index * elementHeight).! !

!PrefabListBox methodsFor: 'private' stamp: 'cr 2/27/2000 21:34'!
selectLabel: aLabel
	"Pvt-Mark 'aLabel' as selected and perform whatever associated events are required."

	aLabel color: selectColor;
		foregroundColor: self selectForeground.
	selection add: aLabel.

	selectResponse invokeWith: (self at: (indices at: aLabel)) second! !

!PrefabListBox methodsFor: 'private' stamp: 'cr 1/8/2000 01:11'!
updateSlider
	"Position and size the slider of the attached vertical scroll bar (if it exists)
	 to reflect the current position and viewable ratio."
	vScrollBar ifNotNil: [
		vScrollBar ratio: self visibleRatio;
			fractionalPositionQuiet: self fractionalPosition;
			stepSize: 1.0/self size.
	].! !

!PrefabListBox methodsFor: 'private' stamp: 'cr 12/21/1999 00:47'!
visibleLines
	"Return number of lines displayable at current size."
	^self innerBounds height // elementHeight! !

!PrefabListBox methodsFor: 'construction' stamp: 'cr 2/13/2000 19:28'!
attributeList
	"Return a collection of pairs of (attributeName: value) that can be used to reconstruct
	 this prefab completely."
	^super attributeList
		add: {#elementHeight:. self elementHeight};
		add: {#selectColor:. self selectColor};
		add: {#selectForeground:. self selectForeground};
		add: {#selectionMode:. self selectionMode};
		yourself.
! !

!PrefabListBox methodsFor: 'event handling' stamp: 'cr 12/20/1999 23:25'!
paneClickedEvent: event onLabel: label
	"Select the clicked label, unselecting others if mode is #single."

	label visible
		ifFalse: [^self].

	(selectionMode = #single or: [event shiftPressed not])
		ifTrue: [
			selection do: [ :n | self deSelectLabel: n].
			selection := Set new.
		].

	self selectLabel: label.! !

!PrefabListBox methodsFor: 'misc' stamp: 'cr 1/4/2000 23:47'!
test
	"test method.  fill the listbox with entries."
	1 to: 30 do: [ :x |
		self addLast: {'line #', x printString. x}.
	].! !


!PrefabManager commentStamp: 'cr 3/26/2000 18:28' prior: 0!
This class implements the main window for a Prefab dialog.  It owns the various widgets
and also contains a PrefabResizer whose job it is to rearrange the widgets when the window
(i.e. a Manager) is resized.

Widgets owned and managed by a manager are called "clients".  (This relationship is more or
less the same as the master-slave relationship in Tk.  I changed the terminology because
I read too much Dilbert.)

A subclass, PrefabConstruction, provides drag+drop and source code generation.

!

!PrefabManager reorganize!
('initialization' initialize)
('API' extent: maxSize maxSize: minSize minSize: openInSystemWindow openInSystemWindowNamed: title:)
('API-client management' addClient: addClient:atRelPosition: addClient:onFailure: clientWithTag: clients hasClient: removeClient: resizer resizer:)
('change reporting' layoutChanged)
('construction' attributeList)
('menu')
('extent operations' closestAllowedTo:)
('tests' canResizeTo: isResizable)
('events' handlesMouseDown:)
('private' privateRemoveMorph:)
!


!PrefabManager methodsFor: 'initialization' stamp: 'cr 3/26/2000 18:18'!
initialize
	super initialize.

	self resizer: PrefabResizer new.
	minSize := 10@10.							"Prevent a divide-by-zero."
	maxSize := SmallInteger maxVal asPoint.	"As close to infinity as is reasonable."
	beingResized := false.


! !

!PrefabManager methodsFor: 'API' stamp: 'cr 3/26/2000 18:29'!
extent: newExtent
	| ne |
	"Set extent to the value closest to newExtent that is still within minSize and maxSize."

	"If extent is being called recursively through the wrapper, do nothing."
	beingResized
		ifTrue: [^self].

	ne := self closestAllowedTo: newExtent.

	"If we're in a system window, resize it appropriately first."
	(self owner isKindOf: SystemWindow)
		ifTrue: [
			"Set beingResized to true while resizing the wrapper so we don't get an infinite recursion
			 when #extent: gets called by it.  This really should be done differently, but this is easiest
			 for the moment."

			beingResized := true.

			super extent: ne.
			self owner extent: (self owner extentWithClientSized: ne).

			beingResized := false.
		] ifFalse: [
			super extent: ne.
		].! !

!PrefabManager methodsFor: 'API' stamp: 'cr 7/8/1999 19:47'!
maxSize
	"Return value of instance variable 'maxSize'"
	^maxSize! !

!PrefabManager methodsFor: 'API' stamp: 'cr 7/10/1999 20:51'!
maxSize: aPoint
	maxSize := aPoint.
	self extent: self extent.			"Resize if necessary."
! !

!PrefabManager methodsFor: 'API' stamp: 'cr 7/8/1999 19:47'!
minSize
	"Return value of instance variable 'minSize'"
	^minSize! !

!PrefabManager methodsFor: 'API' stamp: 'cr 7/10/1999 20:51'!
minSize: aPoint
	minSize := aPoint.
	self extent: self extent.			"Resize if necessary."
! !

!PrefabManager methodsFor: 'API' stamp: 'cr 3/26/2000 15:45'!
openInSystemWindow
	"Put this Manger into a system window.  Return the system window."
	| nm |
	
	"If this Manager is already open (i.e. in a World), close it."
	self world
		ifNotNil: [self delete].

	title isNil
		ifTrue: [self title: 'Prefab Manager'].

	(nm := Prefab managerFrameClass new)
		client: self;
		setLabel: title;
		openInWorld.

	^nm
! !

!PrefabManager methodsFor: 'API' stamp: 'cr 3/26/2000 15:45'!
openInSystemWindowNamed: aString
	"Put this Manger into a system window named with 'aString'.  Return the system window."

	self title: aString.
	^self openInSystemWindow.! !

!PrefabManager methodsFor: 'API' stamp: 'cr 3/26/2000 15:40'!
title: aString
	"Set the title (i.e. the text displayed in the title bar if this gets put in a system window) to
	 'aString'."

	(self owner isKindOf: SystemWindow)
		ifTrue: [self owner setLabel: aString].

	title := aString.
! !

!PrefabManager methodsFor: 'API-client management' stamp: 'cr 12/1/1999 22:18'!
addClient: aMorph
	"Attempt to add aMorph to the manager's collection of clients.  It is assumed that the
	 morph is correctly positioned relative to the manager.  Raise error on failure."
	self addClient: aMorph onFailure: [self error: 'unable to place ', aMorph printString, ' .'].! !

!PrefabManager methodsFor: 'API-client management' stamp: 'cr 12/1/1999 22:18'!
addClient: aMorph atRelPosition: aPoint
	"Attempt to add aMorph to the manager's collection of clients at a location indicated by
	 aPoint, which is a point relative to my origin."
	aMorph position: aPoint + self innerBounds origin.
	self addClient: aMorph! !

!PrefabManager methodsFor: 'API-client management' stamp: 'cr 2/24/2000 22:33'!
addClient: aMorph onFailure: aBlock
	"Attempt to add aMorph to the manager's collection of clients.  It is assumed that the morph
	 is correctly positioned relative to the manager.  Evaluate aBlock on failure."

	"Make sure aMorph is within my bounds."
	(self innerBounds containsRect: aMorph bounds)
		ifFalse: [aBlock value. ^self].

	"Make aMorph the submorph of the appropriate element, either self or a hollow 
	 Prefab (e.g. a PrefabFrame)."
	(resizer ownerFor: aMorph) addMorph: aMorph.

	"Add aMorph to the resizer's list of managed morphs."
	(resizer hasClient: aMorph)
		ifTrue: [resizer removeClient: aMorph].
	resizer addClient: aMorph.


! !

!PrefabManager methodsFor: 'API-client management' stamp: 'cr 7/15/1999 00:18'!
clientWithTag: aSymbol
	"Return the first client with tag = aSymbol. or nil on failure."

	aSymbol ifNil: [^nil]. "Paranoia"

	self clients do: [ :client |
		client tag = aSymbol
			ifTrue: [^client]
		].

	^nil.! !

!PrefabManager methodsFor: 'API-client management' stamp: 'cr 2/23/2000 21:43'!
clients
	^resizer clients.! !

!PrefabManager methodsFor: 'API-client management' stamp: 'cr 2/23/2000 21:43'!
hasClient: aMorph
	"Test if aMorph is a client.  Note that this tests only if 'aMorph' is referenced by this
	 Manager's Resizer, not if it's a submorph of self.  (It's a rather sloppy invariant that a
	 Prefab is a client if and only if it's a submorph.)"
	^resizer hasClient: aMorph.! !

!PrefabManager methodsFor: 'API-client management' stamp: 'cr 2/23/2000 21:44'!
removeClient: aMorph
	resizer removeClient: aMorph.
	World addMorph: aMorph.
	! !

!PrefabManager methodsFor: 'API-client management' stamp: 'cr 2/23/2000 21:32'!
resizer
	"Return the current Resizer."
	^resizer! !

!PrefabManager methodsFor: 'API-client management' stamp: 'cr 2/23/2000 21:31'!
resizer: aResizer
	"Set the resizer to 'aResizer'.  For the moment, this *must* be done before any clients
	 have been added."

	(resizer notNil and: [resizer clients isEmpty not])
		ifTrue: [self error: 'switching resizers on a manager with clients doesn''t work yet.'].

	resizer := aResizer.
	resizer window: self.! !

!PrefabManager methodsFor: 'change reporting' stamp: 'cr 2/23/2000 21:44'!
layoutChanged
	
	resizer newSizesDo: [ :morph :parcel | morph bounds: parcel].
	^super layoutChanged.
! !

!PrefabManager methodsFor: 'construction' stamp: 'cr 1/8/2000 01:31'!
attributeList
	"Return a collection of pairs of (attributeName: value) that can be used to reconstruct
	 this prefab completely."
	^super attributeList
		add: {#minSize:. self minSize};
		add: {#maxSize:. self maxSize};
		yourself.
! !

!PrefabManager methodsFor: 'extent operations' stamp: 'cr 3/19/2000 20:31'!
closestAllowedTo: newExtent
	"Return a point containing the extent closest to 'newExtent' while still within the range of
	 minSize and maxSize."
	^(newExtent max: self minSize) min: self maxSize! !

!PrefabManager methodsFor: 'tests' stamp: 'cr 2/23/2000 22:49'!
canResizeTo: aPoint
	"Return true if this Manager will allow itself to be resized to extent 'aPoint'."
	^aPoint >= minSize and: [aPoint <= maxSize]! !

!PrefabManager methodsFor: 'tests' stamp: 'cr 7/8/1999 19:50'!
isResizable
	^self maxSize > self minSize.! !

!PrefabManager methodsFor: 'events' stamp: 'cr 3/26/2000 12:14'!
handlesMouseDown: evt
	"Eat mouse-down events if this Manager has a window frame (i.e. it's a proper
	 top-level window."
	^self owner isKindOf: Prefab managerFrameClass.! !

!PrefabManager methodsFor: 'private' stamp: 'cr 2/23/2000 21:44'!
privateRemoveMorph: aMorph
	"If aMorph is a prefab, notify the resizer of the change."

	(aMorph isPrefab and: [resizer hasClient: aMorph])
		ifTrue: [resizer removeClient: aMorph].

	super privateRemoveMorph: aMorph.! !


!Calculator commentStamp: 'cr 3/10/2000 04:48' prior: 0!
This is a simple little calculator as can be found with any GUI from the early eighties on.  It's
not particularly useful but it looks nice and illustrates the RubberSheetResizer and how to hook
behaviour into the various GUI components.

!

!Calculator reorganize!
('states' appendKey: clear clearEntry eval)
('construction' addSemanticActions buildOn:)
('initialization' initialize)
!


!Calculator methodsFor: 'states' stamp: 'cr 12/1/1999 22:59'!
appendKey: aString

	| origText |
	clearFirst
		ifTrue: [
			origText := ''.
			clearFirst := false
		] ifFalse: [
			origText := display text.
		].
	display text: origText, aString.
! !

!Calculator methodsFor: 'states' stamp: 'cr 12/1/1999 23:00'!
clear
	"Clear the display."
	display text: '0'.
	clearFirst := true.
! !

!Calculator methodsFor: 'states' stamp: 'cr 12/1/1999 22:55'!
clearEntry
	self clear.! !

!Calculator methodsFor: 'states' stamp: 'cr 12/2/1999 00:15'!
eval
	| result |
	clearFirst := true.

	[result := Compiler evaluate: '^ ', display text for: nil notifying: nil logged: false. ] 
		ifError: [ :err :rcvr | result := nil].

	result = nil
		ifTrue: [display text: 'Error!!!!!!']
		ifFalse: [display text: result printString].


! !

!Calculator methodsFor: 'construction' stamp: 'cr 12/3/1999 05:43'!
addSemanticActions
	"Make the buttons do stuff when pushed."
	
	| button |
	
	0 to: 9 do: [ :num |
		button := self clientWithTag: ('b', num storeString) asSymbol.
		button target: self;
			action: #appendKey:;
			args: (Array with: num asString).
	].

	(self clientWithTag: #decimal)
		target: self;
		action: #appendKey:;
		args: (Array with: '.').

	#(clear clearEntry eval) do: [ :key |
		button := self clientWithTag: key.
		button target: self;
			action: key.
	].

	#( + - * /) do: [ :key |
		button := self clientWithTag: key.
		button target: self;
			action: #appendKey:;
			args: (Array with: key asString).
	].! !

!Calculator methodsFor: 'construction' stamp: 'cr 1/8/2000 02:56'!
buildOn: aManager
	"Caution--automatically-generated method."

	aManager
		extent: 218@299;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: Color black;
		minSize: 10@10;
		maxSize: 1073741823@1073741823.

	aManager addClient: (PrefabFrame new
		extent: 178@42;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: Color black;
		yourself)
		atRelPosition: 19@19.

	aManager addClient: (PrefabButton new
		extent: 40@40;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: Color black;
		tag: #b6;
		text: '6';
		contentOrientation: #centered;
		yourself)
		atRelPosition: 99@159.

	aManager addClient: (PrefabButton new
		extent: 60@40;
		color: (Color r: 1.0 g: 0.194 b: 0.161);
		foregroundColor: Color black;
		tag: #clear;
		text: 'Clear';
		contentOrientation: #centered;
		yourself)
		atRelPosition: 139@79.

	aManager addClient: (PrefabButton new
		extent: 40@40;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: Color black;
		tag: #/;
		text: '/';
		contentOrientation: #centered;
		yourself)
		atRelPosition: 159@239.

	aManager addClient: (PrefabButton new
		extent: 40@40;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: Color black;
		tag: #-;
		text: '-';
		contentOrientation: #centered;
		yourself)
		atRelPosition: 159@159.

	aManager addClient: (PrefabButton new
		extent: 39@40;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: Color black;
		tag: #b4;
		text: '4';
		contentOrientation: #centered;
		yourself)
		atRelPosition: 19@159.

	aManager addClient: (PrefabButton new
		extent: 40@40;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: Color black;
		tag: #b2;
		text: '2';
		contentOrientation: #centered;
		yourself)
		atRelPosition: 59@199.

	aManager addClient: (PrefabButton new
		extent: 40@40;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: Color black;
		tag: #decimal;
		text: '.';
		contentOrientation: #centered;
		yourself)
		atRelPosition: 59@239.

	aManager addClient: (PrefabButton new
		extent: 40@40;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: Color black;
		tag: #b5;
		text: '5';
		contentOrientation: #centered;
		yourself)
		atRelPosition: 59@159.

	aManager addClient: (PrefabButton new
		extent: 40@40;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: Color black;
		tag: #b3;
		text: '3';
		contentOrientation: #centered;
		yourself)
		atRelPosition: 99@199.

	aManager addClient: (PrefabButton new
		extent: 40@40;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: Color black;
		tag: #b9;
		text: '9';
		contentOrientation: #centered;
		yourself)
		atRelPosition: 99@119.

	aManager addClient: (PrefabButton new
		extent: 40@40;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: Color black;
		tag: #*;
		text: '*';
		contentOrientation: #centered;
		yourself)
		atRelPosition: 159@199.

	aManager addClient: (PrefabButton new
		extent: 40@40;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: Color black;
		tag: #b8;
		text: '8';
		contentOrientation: #centered;
		yourself)
		atRelPosition: 59@119.

	aManager addClient: (PrefabButton new
		extent: 40@40;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: Color black;
		tag: #+;
		text: '+';
		contentOrientation: #centered;
		yourself)
		atRelPosition: 159@119.

	aManager addClient: (PrefabButton new
		extent: 40@40;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: Color black;
		tag: #b0;
		text: '0';
		contentOrientation: #centered;
		yourself)
		atRelPosition: 19@239.

	aManager addClient: (PrefabButton new
		extent: 40@40;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: Color black;
		tag: #b1;
		text: '1';
		contentOrientation: #centered;
		yourself)
		atRelPosition: 19@199.

	aManager addClient: (PrefabButton new
		extent: 39@40;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: Color black;
		tag: #b7;
		text: '7';
		contentOrientation: #centered;
		yourself)
		atRelPosition: 19@119.

	aManager addClient: (PrefabButton new
		extent: 120@40;
		color: (Color r: 1.0 g: 0.71 b: 0.677);
		foregroundColor: Color black;
		tag: #clearEntry;
		text: 'Clear Entry';
		contentOrientation: #centered;
		yourself)
		atRelPosition: 19@79.

	aManager addClient: (PrefabLabel new
		extent: 167@27;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: Color black;
		tag: #display;
		text: '0';
		contentOrientation: #right;
		yourself)
		atRelPosition: 24@29.

	aManager addClient: (PrefabButton new
		extent: 40@40;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: Color black;
		tag: #eval;
		text: '=';
		contentOrientation: #centered;
		yourself)
		atRelPosition: 99@239.
! !

!Calculator methodsFor: 'initialization' stamp: 'cr 2/26/2000 22:29'!
initialize
	super initialize.

	self resizer: RubberSheetResizer new.

	clearFirst := true.

	self buildOn: self.

	display := self clientWithTag: #display.
	self addSemanticActions.
! !


!EditorFrame commentStamp: 'cr 3/10/2000 04:45' prior: 0!
A widget containing a PrefabEditor.  Demonstrates the use of the FixedDistanceResizer.  Doesn't
actually do anything useful.!

!EditorFrame methodsFor: 'as yet unclassified' stamp: 'cr 2/26/2000 22:55'!
buildOn: aManager
	"Caution--automatically-generated method."

	aManager
		extent: 633@441;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		minSize:  300@200;
		maxSize: 99999@99999.

	aManager addClient: (PrefabFrame new
		extent: 623@40;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		style: #raised;
		tag: #buttonBar;
		yourself)
		atRelPosition: 3@3.

	aManager addClient: (PrefabScrollBar new
		extent: 20@386;
		color: (Color r: 0.6 g: 0.6 b: 0.8);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		tag: #scroller;
		orientation: #vertical;
		yourself)
		atRelPosition: 607@47.

	aManager addClient: (PrefabButton new
		extent: 63@28;
		color: (Color r: 1.0 g: 0.599 b: 0.599);
		foregroundColor: (Color r: 0.125 g: 0.125 b: 0.125);
		tag: #reverseButton;
		text: 'Reverse';
		contentOrientation: #centered;
		yourself)
		atRelPosition: 80@8.

	aManager addClient: (PrefabEdit new
		extent: 604@388;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		tag: #editor;
		yourself)
		atRelPosition: 3@47.

	aManager addClient: (PrefabButton new
		extent: 67@28;
		color: (Color r: 0.0 g: 1.0 b: 0.4);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		tag: #clearButton;
		text: 'Clear';
		contentOrientation: #centered;
		yourself)
		atRelPosition: 10@8.

	aManager addClient: (PrefabButton new
		extent: 71@28;
		color: (Color r: 0.4 g: 0.8 b: 1.0);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		tag: #fillButton;
		text: 'Fill';
		contentOrientation: #centered;
		yourself)
		atRelPosition: 146@8.
! !

!EditorFrame methodsFor: 'as yet unclassified' stamp: 'cr 2/26/2000 22:44'!
fixEdges
	"Set the resizer to do the right thing when the window is resized."

	self resizer
		fixBottomOf: editor;
		fixRightOf: editor;

		fixLeftOf: scroller;
		fixRightOf: scroller;
		fixBottomOf: scroller;

		fixRightOf: (self clientWithTag: #buttonBar).
	! !

!EditorFrame methodsFor: 'as yet unclassified' stamp: 'cr 2/26/2000 22:33'!
initialize
	| s |
	super initialize.

	self resizer: FixedDistanceResizer new.

	self buildOn: self.

	editor := self clientWithTag: #editor.
	scroller := self clientWithTag: #scroller.

	editor text: ''.

	(self clientWithTag: #clearButton) action: [editor text: ''].
	(self clientWithTag: #reverseButton) action: [editor text: editor text reversed].
	(self clientWithTag: #fillButton) action: [
		s := WriteStream on: (String new: 200).
		s tab.
		200 timesRepeat: [
			s nextPutAll: 'All work and no play make Jack a dull boy.  '.
			(1 to: 8) atRandom = 1
				ifTrue: [s cr; tab].
		].
		editor text: s contents.
		s := nil.		"Save some RAM.  Hey, why not?"
	].
	
	editor vScrollBar: scroller.

	self fixEdges.! !


!PrefabConstruction commentStamp: 'cr 3/26/2000 18:46' prior: 0!
This is a kind of PrefabManager that supports construction. It allows other Prefabs to 
be dropped into it and will produce source code for a method that recreates its current
layout.

Note to hackers:  The resizer (a PrefabResizer, which does nothing) isn't necessarily
kept updated.  In particular, if you move a submorph without picking it up (sometimes
necessary), the resizer keeps the old bounds.  This currently works because the resizer's
dimensions aren't actually used for anything in a PrefabConstruction. (The keys--the
list of Prefabs to manage, are used.)

If you ever decide to add code that uses it, you'll be opening a pretty big can of worms.

!

!PrefabConstruction reorganize!
('dragging/dropping' acceptDroppingMorph:event: allowSubmorphExtraction repelsMorph:event: wantsDroppedMorph:event:)
('menu' addCustomMenuItems:hand: displayConstructionMethod fixSize setFixedSize setMaxSize setMinSize)
('construction' constructionMethodSourceNamed:)
('private-construction' buildFromList:indent:on: buildFromMorphCollection:on: writeAttribute:on:)
!


!PrefabConstruction methodsFor: 'dragging/dropping' stamp: 'cr 3/18/2000 11:59'!
acceptDroppingMorph: aMorph event: evt
	"Allow the user to add submorphs just by dropping them on this morph."
	
	"Transcript nextPutAll: 'dropping ', aMorph printString; cr; endEntry."

	aMorph bounds: aMorph bounds.
	self addClient: aMorph.
! !

!PrefabConstruction methodsFor: 'dragging/dropping' stamp: 'cr 7/9/1999 21:20'!
allowSubmorphExtraction
	
	^ true.! !

!PrefabConstruction methodsFor: 'dragging/dropping' stamp: 'cr 8/6/1999 21:15'!
repelsMorph: aMorph event: evt
	^(self wantsDroppedMorph: aMorph event: evt) not
! !

!PrefabConstruction methodsFor: 'dragging/dropping' stamp: 'cr 3/18/2000 11:59'!
wantsDroppedMorph: aMorph event: evt
	"Return true if the receiver wishes to accept the given morph, which is being dropped by a
	 hand in response to the given event."

	"Transcript nextPutAll: 'wants ', aMorph innerBounds printString; cr; endEntry."

	^ aMorph isPrefab and: [self innerBounds containsRect: aMorph bounds]! !

!PrefabConstruction methodsFor: 'menu' stamp: 'cr 3/26/2000 20:23'!
addCustomMenuItems: aCustomMenu hand: aHandMorph
	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	
	aCustomMenu add: 'Set minimum size' target: self action: #setMinSize;
		add: 'Set maximum size' target: self action: #setMaxSize;
		add: 'Fix size to current extent' target: self action: #fixSize;
		add: 'Set fixed size' target: self action: #setFixedSize;
		addLine;
		add: 'Display construction source' target: self action: #displayConstructionMethod.
! !

!PrefabConstruction methodsFor: 'menu' stamp: 'cr 7/11/1999 15:33'!
displayConstructionMethod
	"Create the method and display it in a workspace."

	(StringHolder new contents: (self constructionMethodSourceNamed: 'buildOn:'))
		openLabel: 'Method Source'.
! !

!PrefabConstruction methodsFor: 'menu' stamp: 'cr 1/29/2000 19:06'!
fixSize
	"Prevent resizing."
	(nil confirm: 'Set both minimum and maximum sizes to current size?')
		ifFalse: [^self].

	self minSize: self extent.
	self maxSize: self extent.! !

!PrefabConstruction methodsFor: 'menu' stamp: 'cr 1/29/2000 19:07'!
setFixedSize
	"Prompt for a size and set both the minimum and maximum sizes to it."
	| newSize |
	newSize := self class queryPoint: self extent named: 'fixed size'.
	self minSize: newSize.
	self maxSize: newSize.! !

!PrefabConstruction methodsFor: 'menu' stamp: 'cr 1/29/2000 19:07'!
setMaxSize
	self maxSize: (self class queryPoint: self maxSize named: 'maximum size').! !

!PrefabConstruction methodsFor: 'menu' stamp: 'cr 1/29/2000 19:27'!
setMinSize
	self minSize: (self class queryPoint: self minSize named: 'minimum size').! !

!PrefabConstruction methodsFor: 'construction' stamp: 'cr 3/26/2000 19:34'!
constructionMethodSourceNamed: aString
	"Return the source code for a method that will recreate the layout of this manager."
	| result |
	result := WriteStream on: (String new: 100).
	
	result nextPutAll: aString.
	aString last = $: ifFalse: [result nextPut: $:].

	result nextPutAll: ' aManager'; cr; tab; 
		nextPutAll: '"Caution--automatically-generated method."'; cr; cr; tab;
		nextPutAll: 'aManager'; cr; tab; tab.

	self buildFromList: self attributeList indent: 2 on: result.
	result nextPut: $.; cr.

	"Hollow items need to be put down first."
	self buildFromMorphCollection: resizer sortedClients on: result.

	"Now the solid bits."
"	self buildFromMorphCollection: resizer nonHollowClients on: result."
		
	^result contents.
! !

!PrefabConstruction methodsFor: 'private-construction' stamp: 'cr 1/29/2000 16:51'!
buildFromList: aCollection indent: depthInt on: aWriteStream
	| last |
	"Append Smalltalk method calls and arguments onto 'aWriteStream'."
	 
	aCollection allButLast do: [ :attr |
		attr second
			ifNotNil: [
				self writeAttribute: attr on: aWriteStream.
				aWriteStream nextPut: $;; cr.
				1 to: depthInt do: [ :x | aWriteStream tab].
			].
	].

	last := aCollection last.
	last second
		ifNotNil: [self writeAttribute: last on: aWriteStream].
! !

!PrefabConstruction methodsFor: 'private-construction' stamp: 'cr 1/29/2000 16:28'!
buildFromMorphCollection: aCollection on: resultStream
	
	aCollection do: [ :m |
		resultStream cr; tab; 
			nextPutAll: 'aManager addClient: ('; 
			nextPutAll: m class name;
			nextPutAll: ' new'; cr; tab; tab.

		self buildFromList: m attributeList indent: 2 on: resultStream.
		resultStream nextPut: $;; cr; 
			tab; tab; nextPutAll: 'yourself)';	cr.

		resultStream tab; tab; nextPutAll: 'atRelPosition: ';
			nextPutAll: (m bounds origin - self innerBounds origin) storeString;
			nextPut: $.;
			cr.
	].
! !

!PrefabConstruction methodsFor: 'private-construction' stamp: 'cr 1/29/2000 16:50'!
writeAttribute: attr on: aWriteStream
	"Write a string of Squeak code to set this attribute on aWriteStream."
	aWriteStream nextPutAll: attr first asString;
		nextPutAll: ' ';
		nextPutAll: attr second storeString.
! !


!PrefabManager class reorganize!
('API-instance creation' newInSystemWindow newInSystemWindowNamed:)
!


!PrefabManager class methodsFor: 'API-instance creation' stamp: 'cr 3/26/2000 15:49'!
newInSystemWindow
	"Create and open a new instance but contained in a system window."
	^self new openInSystemWindow; yourself.! !

!PrefabManager class methodsFor: 'API-instance creation' stamp: 'cr 3/26/2000 15:48'!
newInSystemWindowNamed: aString
	"Create and open a new instance but contained in a system window."
	^self new openInSystemWindowNamed: aString; yourself.
! !


!Calculator class reorganize!
('instance creation' newInSystemWindow)
!


!Calculator class methodsFor: 'instance creation' stamp: 'cr 2/23/2000 22:03'!
newInSystemWindow
	^super newInSystemWindowNamed: 'Cheesy Calculator'.! !


!PrefabConstruction class reorganize!
('class constants' defaultGridSize)
!


!PrefabConstruction class methodsFor: 'class constants' stamp: 'cr 7/17/1999 00:01'!
defaultGridSize
	"Const."
	^20@20! !


!PrefabManagerWrapper commentStamp: 'cr 2/27/2000 18:38' prior: 0!
This is a subclass of SystemWindow designed specifically to contain a single PrefabManager (or subinstance
thereof) in a manner compatible with the requirements of a Prefab construction.  Currently, this comes
down to preserving the Manager's current extent, restricting user resises to what it can tolerate and
resizing the Manager when the window is resized.
!

!PrefabManagerWrapper reorganize!
('all' client client: clientExtent: clientSizeWithExtent: extent: extentWithClientSized: initialExtent)
!


!PrefabManagerWrapper methodsFor: 'all' stamp: 'cr 1/9/2000 00:47'!
client
	"Client is the single morph--a PrefabManager--that occupies the entire client area."
	^client! !

!PrefabManagerWrapper methodsFor: 'all' stamp: 'cr 1/9/2000 01:16'!
client: aPrefabManager
	"Client is the single morph--a PrefabManager--that occupies the entire client area."
	client := aPrefabManager.
	self clientExtent: aPrefabManager extent.
	self addMorph: aPrefabManager frame: (0@0 extent: 1@1).	! !

!PrefabManagerWrapper methodsFor: 'all' stamp: 'cr 1/9/2000 21:23'!
clientExtent: newExtent
	"Set extent so that client area has an extent of 'newExtent'."

	self extent: (self extentWithClientSized: newExtent).! !

!PrefabManagerWrapper methodsFor: 'all' stamp: 'cr 2/23/2000 22:52'!
clientSizeWithExtent: aPoint
	"Return the extent of the client region if the extent is set to 'aPoint'."

	^aPoint - ((0 @ self labelRect extent y) + (self borderWidth * 2)).
! !

!PrefabManagerWrapper methodsFor: 'all' stamp: 'cr 2/23/2000 23:08'!
extent: aPoint
	| pt |
	"Set extent to 'aPoint' unless the client won't be resized to that size."

	pt := aPoint.
	client ifNotNil: [
		pt := self extentWithClientSized: (client closestAllowedTo: (self clientSizeWithExtent: pt)).
	].

	^super extent: pt.! !

!PrefabManagerWrapper methodsFor: 'all' stamp: 'cr 1/9/2000 21:00'!
extentWithClientSized: clientExtent
	"Return extent of self such that client area has extent 'clientExtent'."

	^clientExtent + (0 @ self labelRect extent y) + (self borderWidth * 2).! !

!PrefabManagerWrapper methodsFor: 'all' stamp: 'cr 1/9/2000 21:27'!
initialExtent
	client
		ifNil: [^super initialExtent].

	^ self extentWithClientSized: client extent.! !


!PrefabRadioButton commentStamp: 'cr 3/19/2000 19:57' prior: 0!
This class implements a radio button.  Radio buttons are like check buttons except that
only one button in a particular group can be selected at any one time.  A group is determined
by morph ownership.  That is, all PrefabRadioButtons owned by one morph are considered
the group.  If you want to have a bunch of independent groups of radio buttons on the
same window, put PrefabFrames in the manager and drop the radio buttons in the frame.
(If you don't like having frames, just make them the same color as the Manager and give them
flush borders--nobody will notice.)

See the class comment of PrefabResponse for an explanation of how callbacks work.

!

!PrefabRadioButton reorganize!
('initialization' initialize)
('API' isSelected:)
('event handling' clicked)
('private' deselectAllOthers fixedHeight labelOrigin minimumWidth switchPosition)
!


!PrefabRadioButton methodsFor: 'initialization' stamp: 'cr 7/25/1999 16:59'!
initialize
	super initialize.
	switch extent: Prefab radioButtonExtent;
		borderWidth: 1;
		toggleMode: false;
		clickedColor: Prefab radioButtonCheckedColor.

	label text: 'A Radio-Button'.

	"Resize to something reasonable.  Height is fixed so we don't care about it."
	self extent: (label idealExtent x + ((self borderWidth + switch extent x) * 3)) @ 0.
! !

!PrefabRadioButton methodsFor: 'API' stamp: 'cr 7/25/1999 18:13'!
isSelected: aBoolean
	"Set selection.  If set to true, first deselect any other sibling PrefabRadioButtons
	 (i.e. radio buttons that are submorphs of my owner."

	aBoolean ifTrue: [self deselectAllOthers].

	super isSelected: aBoolean.! !

!PrefabRadioButton methodsFor: 'event handling' stamp: 'cr 7/25/1999 18:17'!
clicked
	self isSelected
		ifTrue: [self deselectAllOthers].

	^super clicked.! !

!PrefabRadioButton methodsFor: 'private' stamp: 'cr 7/25/1999 18:13'!
deselectAllOthers
	"Deselect all other PrefabRadioButton submorphs of my owner."

	self owner submorphsDo: [ :morph |
		((morph isKindOf: PrefabRadioButton) and: [morph ~= self])
			ifTrue: [morph isSelected: false].
	].! !

!PrefabRadioButton methodsFor: 'private' stamp: 'cr 7/25/1999 00:08'!
fixedHeight
	^switch bounds height * 3.! !

!PrefabRadioButton methodsFor: 'private' stamp: 'cr 7/25/1999 00:12'!
labelOrigin
	"Return the point to be the origin of the label."
	^(self innerBounds origin + (switch bounds width * 2)) x @ self innerBounds origin y.! !

!PrefabRadioButton methodsFor: 'private' stamp: 'cr 7/25/1999 00:25'!
minimumWidth
	"Return the smallest size to which the button can be sized."
	^switch bounds width * 2.! !

!PrefabRadioButton methodsFor: 'private' stamp: 'cr 7/25/1999 00:11'!
switchPosition
	"Return the position to be occupied by actual button part."
	^self bounds origin + ((switch extent x // 2) @ (switch extent y)).! !


!PrefabResizer commentStamp: 'cr 2/27/2000 03:06' prior: 0!
This class retains a list of clients belonging to a Manager as well as their positions and does
real-estate management for them.  In particular, it resizes and repositions the clients
when the manager is resized. Subclasses implement different policies.  This one implements
the default--do nothing.  It works OK on non-resizable dialogs but if you want a dialog
that can be resized, use a RubberSheetResizer or FixedDistanceResizer.

It is the programmer's responsibility to set the Manager's maximum and minimum sizes to
something reasonable.  It's possible to get ugliness or divide by zero errors if you let the user
make a window too small.
!

!PrefabResizer reorganize!
('initialization' initialize)
('accessing' window:)
('resize policy' convertRect: newSizesDo:)
('tests' hasClient:)
('client accessing' clients hollowClients nonHollowClients sortedClients)
('private')
('client management' addClient: ownerFor: removeClient:)
!


!PrefabResizer methodsFor: 'initialization' stamp: 'cr 7/5/1999 22:35'!
initialize
	parcels := IdentityDictionary new.
! !

!PrefabResizer methodsFor: 'accessing' stamp: 'cr 7/5/1999 22:52'!
window: aPrefabManager
	window := aPrefabManager.! !

!PrefabResizer methodsFor: 'resize policy' stamp: 'cr 2/23/2000 21:07'!
convertRect: aMorph
	"Return some object based on 'aMorph' that can be used later
	 to resize 'aMorph' as is consistant with the Layout (e.g. a rectangle
	 of aMorph's bounds scaled relative to a 1@1 rectangle.)  The default
	 is simply the bounds relative to the Manager's origin."
	^aMorph bounds translateBy: window innerBounds origin negated.! !

!PrefabResizer methodsFor: 'resize policy' stamp: 'cr 2/18/2000 22:35'!
newSizesDo: aBlock
	"Evaluate aBlock, a two-argument block, over all parcels where arg1 is the morph and
	 arg2 is the parcel.  The parcel must be adjusted to reflect the absolute bounds of the
	 client at this time.

	 Default--no resize."
! !

!PrefabResizer methodsFor: 'tests' stamp: 'cr 1/10/2000 23:48'!
hasClient: aMorph
	^parcels includesKey: aMorph! !

!PrefabResizer methodsFor: 'client accessing' stamp: 'cr 7/8/1999 20:05'!
clients
	^parcels keys.! !

!PrefabResizer methodsFor: 'client accessing' stamp: 'cr 7/10/1999 22:09'!
hollowClients
	"Return a collection of clients with hollow bits."
	^parcels keys select: [ :m | m isHollow]! !

!PrefabResizer methodsFor: 'client accessing' stamp: 'cr 7/10/1999 22:10'!
nonHollowClients
	"Return a collection of clients without hollow bits."
	^parcels keys select: [ :m | m isHollow not]! !

!PrefabResizer methodsFor: 'client accessing' stamp: 'cr 3/26/2000 19:55'!
sortedClients
	| hm max changed testable |
	"Return a list of clients sorted in order of containerness--that is, such that no hollow morph
	 comes after the things its supposed to contain."

	hm := IdentityDictionary new.
	self hollowClients do: [ :x | hm at: x put: 0].
	max := 0.
	changed := true.

	[changed] whileTrue: [
		changed := false.

		testable := (hm keys select: [ :item | (hm at: item) >= max]) asArray.

		testable do: [ :first |
			testable do: [ :second |
				((first == second) not and: [first bounds containsRect: second bounds])
					ifTrue: [
						hm at: second put: max + 1.
						changed := true.
					].
			].
		].

		max := max + 1.
	].

	^(hm keys asSortedCollection: [ :l :r | (hm at: l) < (hm at: r)]) asArray, 
			self nonHollowClients asArray.
	

			
! !

!PrefabResizer methodsFor: 'client management' stamp: 'cr 2/23/2000 21:00'!
addClient: aMorph
	"See if the requested parcel (defined by aRectangle) is available for aMorph and if so,
	 allocate it.  Return true on success, false if parcel is not available."

	| iform |
	iform := self convertRect: aMorph.
	parcels at: aMorph put: iform.
! !

!PrefabResizer methodsFor: 'client management' stamp: 'cr 2/20/2000 19:39'!
ownerFor: aMorph
	"Return the morph that should own 'aMorph', a morph that is already registered here.
	 Normally, it's the manager that owns this Layout but it might also be a hollow morph
	 that contains 'aMorph'."

	| p |
	p := aMorph bounds.

	self hollowClients do: [ :client |
		(client innerBounds containsRect: p)
			ifTrue: [^client].
	].

	^window.! !

!PrefabResizer methodsFor: 'client management' stamp: 'cr 7/9/1999 21:43'!
removeClient: aMorph
	"Remove 'aMorph'."
	parcels removeKey: aMorph.! !

Smalltalk renameClassNamed: #FixedDistanceLayout as: #FixedDistanceResizer!

!FixedDistanceResizer commentStamp: 'cr 3/19/2000 19:31' prior: 0!
This class implements a semi-intelligent way of allowing windows to be resized by letting
the programmer fix the positions of some vertices relative to the right or bottom edges of the
Manager.

For example, an EditorFrame contains a PrefabFrame full of buttons, a PrefabEdit and
a PrefabScrollbar.  (To take a look at it, evaluate this:

	EditorFrame newInSystemWindow

) 

<more details go here.>

Thanks to Kannan Vijayan for giving me the original idea for this (which he got from Visual
Basic.)!

!FixedDistanceResizer reorganize!
('resize policy' convertRect: newSizesDo:)
('API-Edge fixing' fixBottomOf: fixLeftOf: fixRightOf: fixTopOf:)
!


!FixedDistanceResizer methodsFor: 'resize policy' stamp: 'cr 2/26/2000 22:37'!
convertRect: aMorph
	"Return a binding for aRect."
	^PositionalBinding for: aMorph in: window.
	! !

!FixedDistanceResizer methodsFor: 'resize policy' stamp: 'cr 2/24/2000 22:06'!
newSizesDo: aBlock
	"Evaluate aBlock, a two-argument block, over all parcels where arg1 is the morph and
	 arg2 is the new bounds.  This gets called when clients need to be resized."

	parcels associationsDo: [ :assoc |
		aBlock value: assoc key value: assoc value newBounds.
	].
! !

!FixedDistanceResizer methodsFor: 'API-Edge fixing' stamp: 'cr 2/24/2000 22:10'!
fixBottomOf: aMorph
	"Fix the bottom edge of aMorph's position relative the the manager's bottom edge."
	(parcels at: aMorph) fixBottom! !

!FixedDistanceResizer methodsFor: 'API-Edge fixing' stamp: 'cr 2/24/2000 22:11'!
fixLeftOf: aMorph
	"Fix the left edge of aMorph's position relative the the manager's right edge."
	(parcels at: aMorph) fixLeft! !

!FixedDistanceResizer methodsFor: 'API-Edge fixing' stamp: 'cr 2/24/2000 22:11'!
fixRightOf: aMorph
	"Fix the right edge of aMorph's position relative the the manager's right edge."
	(parcels at: aMorph) fixRight! !

!FixedDistanceResizer methodsFor: 'API-Edge fixing' stamp: 'cr 2/24/2000 22:11'!
fixTopOf: aMorph
	"Fix the top edge of aMorph's position relative the the manager's bottom edge."
	(parcels at: aMorph) fixTop! !


!PrefabResizer class methodsFor: 'instance creation' stamp: 'cr 7/5/1999 22:35'!
new
	^super new initialize.! !


!PrefabResponse commentStamp: 'cr 3/19/2000 19:10' prior: 0!
This class implements the basic callback mechanism for Prefab widgets.  When sent the message 
#invoke or #invokeWith: (or variants thereof), it does something--either sends a message to an object
or evaluate a block, possibly with arguments.  It attempts to be as tolerant as possible.  For example, if
invoked before an action has been assigned, nothing happens.

Typically, a Prefab will provide three methods named #action*:, #args*: and #target*: (where * may be
some other series of letters--or not.)  These typically just do calls the corresponding methods in a
PrefabResponse.  When an event occurs, the widget sends its PrefabResponse the message #invoke (or
some variant thereof) causing an action to be performed.

There are two ways in which an action may be assigned to a PrefabResponse (and, by extension, a Prefab.)
The first is to send #action: with a block context as the argument.  The second is to make the argument
a message name and send #target: with the (non-nil) object that should receive the message when the 
event occurs.  In either case, you can use #args: to set one or more additional arguments to hand off 
to the block or method invocation.  Make sure that your method or block accepts the right number 
of arguments or else you'll be facing the debugger.

Responses attempt to be smart about how they pass arguments.  If the action (i.e. block or message)
requires the same number of arguments as are available, the args are passed on per formal parameter.
If the action requires one argument and more are available however, the args are bundled into an array
and the array passed as the whole argument.  Otherwise, an error occurs.

Note: You should not need to create or otherwise deal with PrefabResponses unless you are hacking on
Prefab itself, rather than just using it.

!

!PrefabResponse reorganize!
('accessing' action: args: target:)
('invocation' invoke invokeWith: invokeWith:with: invokeWith:with:with: invokeWithArgs:)
('private' allArgs:)
!


!PrefabResponse methodsFor: 'accessing' stamp: 'cr 11/24/1999 21:37'!
action: aBlockOrSymbol
	"Set the action to 1) a block to evaluate when the button is pressed or 2) a message to send
	 to either a specified target or the manager's specified target."
	action := aBlockOrSymbol.! !

!PrefabResponse methodsFor: 'accessing' stamp: 'cr 11/24/1999 21:37'!
args: anArray
	"Set args to array of arguments to be used as parameters by action."
	args := anArray.! !

!PrefabResponse methodsFor: 'accessing' stamp: 'cr 11/24/1999 21:38'!
target: anObject
	"The object that gets the message when invoked."
	target := anObject.! !

!PrefabResponse methodsFor: 'invocation' stamp: 'cr 11/28/1999 00:03'!
invoke
	"Invoke with no extra arguments."
	^self invokeWithArgs: #().
! !

!PrefabResponse methodsFor: 'invocation' stamp: 'cr 11/28/1999 00:02'!
invokeWith: arg
	"Invoke with one extra argument."
	^self invokeWithArgs: (Array with: arg).
! !

!PrefabResponse methodsFor: 'invocation' stamp: 'cr 11/28/1999 00:03'!
invokeWith: arg1 with: arg2
	"Invoke with two extra arguments."
	^self invokeWithArgs: (Array with: arg1 with: arg2).
! !

!PrefabResponse methodsFor: 'invocation' stamp: 'cr 11/28/1999 00:04'!
invokeWith: arg1 with: arg2 with: arg3
	"Invoke with three extra arguments."
	^self invokeWithArgs: (Array with: arg1 with: arg2 with: arg3).
! !

!PrefabResponse methodsFor: 'invocation' stamp: 'cr 1/23/2000 20:47'!
invokeWithArgs: extraArgs
	"Send the message or invoke the block, returning the result or nil."

	| tmpArgs |
	action ifNil: [^nil].			"If no action specified, we're done."

	tmpArgs := self allArgs: extraArgs.
	action class = BlockContext
		ifTrue: [
			action numArgs = tmpArgs size
				ifTrue: [
					^action valueWithArguments: tmpArgs.
				].

			"If arg counts don't match and the block only one arg., just pass the
			 whole array."
			action numArgs = 1
				ifTrue: [
					^action value: tmpArgs.
				].

			self error: 'Argument count mismatch in response'.
		].

	target ifNotNil: [
		action numArgs ~= tmpArgs size
			ifTrue: [^self error: 'Argument count mismatch in response'.].

		^target perform: action withArguments: tmpArgs.
	].

	^nil.
! !

!PrefabResponse methodsFor: 'private' stamp: 'cr 11/24/1999 22:06'!
allArgs: extras
	"Return an array containing all arguments for the current invocation.  This consists
	 of 'args' with 'extras' appended."
	| tmpArgs |

	"Shortcut: no arguments."
	args ifNil: [extras ifNil: [^#()]].

	tmpArgs := args.
	tmpArgs ifNil: [
		tmpArgs := Array new.
	].

	"If no extras, we're done."
	extras ifNil: [^tmpArgs].

	(extras isKindOf: SequenceableCollection)
		ifTrue: [^tmpArgs, extras]
		ifFalse: [^tmpArgs, (Array with: extras)].
! !


!PrefabResponse class methodsFor: 'instance creation' stamp: 'cr 11/28/1999 00:22'!
action: aBlockContext
	^self new
		action: aBlockContext;
		yourself.! !

!PrefabResponse class methodsFor: 'instance creation' stamp: 'cr 11/28/1999 00:21'!
target: anObject action: aSymbol
	^self new
		target: anObject;
		action: aSymbol;
		yourself.! !

!PrefabResponse class methodsFor: 'instance creation' stamp: 'cr 11/28/1999 00:21'!
target: anObject action: aSymbol args: anArray
	^self new
		target: anObject;
		action: aSymbol;
		args: anArray;
		yourself.! !


!PrefabScrollBar commentStamp: 'cr 2/27/2000 20:17' prior: 0!
This class implements a Prefab-style scroll bar.  These can be oriented both horizontally
and vertically.

The easiest way to use a scrollbar is simply to pass it to a PrefabEdit or PrefabListBox via
their #vScrollBar: message.  However, you can also take manual control of a scroll bar with
the API.

!

!PrefabScrollBar reorganize!
('initialization' initialize initializeMorph initializeSlider)
('API' extent: fractionalPosition fractionalPosition: fractionalPositionQuiet: orientation orientation: ratio ratio: stepSize stepSize:)
('API-actions' action: args: target:)
('click-and-hold scrolling' advanceScroller startScrollingTowardPointer: step stepTime wantsSteps)
('events' handlesMouseDown: mouseDown: mouseDownInSlider: mouseUp: mouseUpInSlider: sliderDragged: stepBackward stepForward)
('change reporting' layoutChanged)
('dimensions' activeDimension buttonExtent inactiveDimension sliderExtent totalSliderArea usableSliderArea)
('construction' attributeList)
('menu' addCustomMenuItems:hand: setOrientation)
('others' isHorizontal isVertical)
('private' moveSliderToPoint: sliderPosition: updateSliderBounds)
!


!PrefabScrollBar methodsFor: 'initialization' stamp: 'cr 1/8/2000 00:59'!
initialize
	super initialize.

	self borderWidth: 1;
		borderColor: Color black.

	ratio := 0.1.
	stepSize := 0.05.
	orientation
		ifNil: [orientation := #vertical].

	response := PrefabResponse new.

	^self initializeMorph.

! !

!PrefabScrollBar methodsFor: 'initialization' stamp: 'cr 1/20/2000 23:11'!
initializeMorph
	"Create the scroll-bar, assuming that orientation has been set."
	| images form |

	self color: Prefab scrollbarBackgroundColor;
		borderColor: #inset.

	self isVertical
		ifTrue: [
			self width: Prefab defaultScrollbarWidth;
				height: Prefab defaultScrollbarLength.
		] ifFalse: [
			self width: Prefab defaultScrollbarLength;
				height: Prefab defaultScrollbarWidth.
		].

	images := (self isHorizontal ifTrue: [#(rightArrow leftArrow)] ifFalse: [#(downArrow upArrow)])
		collect: [ :n |
			form := Prefab formNamed: n.
			form magnify: form boundingBox 	"Note: was sending magnifyBy: but that's broken in 2.7"
				  by: (self isVertical
						ifTrue: [(self width / 2.0) / form boundingBox width]
						ifFalse: [(self height / 2.0) / form boundingBox height]).

		].

	forwardButton := (PrefabButton new
		image: images first;
		target: self;
		action: #stepForward;
		borderWidth: 1;
		yourself).

	backwardButton := (PrefabButton new
		image: images second;
		target: self;
		action: #stepBackward;
		borderWidth: 1;
		yourself).

	self addMorph: forwardButton;
		addMorph: backwardButton.

	self initializeSlider.

! !

!PrefabScrollBar methodsFor: 'initialization' stamp: 'cr 1/8/2000 01:57'!
initializeSlider
	"Create the slider and give it the relevant event handlers."
	slider := RectangleMorph new color: Prefab scrollbarSliderColor.
	self updateSliderBounds.
	sliderShadow := RectangleMorph newBounds: self totalSliderArea
						color: Prefab scrollbarBackgroundColor.

	slider on: #mouseStillDown send: #sliderDragged: to: self.
	slider on: #mouseDown send: #mouseDownInSlider: to: self.
	slider on: #mouseUp send: #mouseUpInSlider: to: self.

	slider setBorderWidth: 1 borderColor: #raised.
	sliderShadow setBorderWidth: 1 borderColor: #inset.

	self addMorph: sliderShadow.
	sliderShadow hide.
	self addMorph: slider.
! !

!PrefabScrollBar methodsFor: 'API' stamp: 'cr 1/6/2000 00:55'!
extent: aPoint
	| fp |
	"Change extent, preserving slider position."
	
	"Case 1: the morph is incomplete."
	(slider isNil or: [forwardButton isNil or: [backwardButton isNil]])
		ifTrue: [^super extent: aPoint].

	fp := self fractionalPosition.
	super extent: aPoint.
	self fractionalPositionQuiet: fp.! !

!PrefabScrollBar methodsFor: 'API' stamp: 'cr 1/6/2000 01:05'!
fractionalPosition
	| area divisor |
	"Return a number between 0 and 1 indicating where the slider is between the start and
	 end of the scrollbar trough."

	self ratio >= 1
		ifTrue: [^0].

	area := self usableSliderArea.

	divisor := area extent dotProduct: self activeDimension.
	divisor = 0
		ifTrue: [^0].

	self isHorizontal
		ifTrue: [
			^(slider left - area left) asFloat / divisor.
		] ifFalse: [
			^(slider top - area top) asFloat / divisor.
		].! !

!PrefabScrollBar methodsFor: 'API' stamp: 'cr 1/5/2000 05:24'!
fractionalPosition: fr
	"Set the slider position and trigger any set response as if the slider had
	 been dragged.  Argument is a number between 0 and 1 representing the
	 whole range of the slider's movement."

	self fractionalPositionQuiet: fr.
	response invokeWith: self fractionalPosition.
! !

!PrefabScrollBar methodsFor: 'API' stamp: 'cr 1/7/2000 01:42'!
fractionalPositionQuiet: fr
	| fraction range |
	"Set the slider position *without* triggering the normal movement action."

	fraction := fr asFloat.
	
	fraction < 0	ifTrue: [fraction := 0.0].
	fraction > 1 ifTrue: [fraction := 1.0].

	range := self isVertical 
		ifTrue: [self usableSliderArea extent y]
		ifFalse: [self usableSliderArea extent x].

	self sliderPosition: (range * fraction) rounded.
	! !

!PrefabScrollBar methodsFor: 'API' stamp: 'cr 1/6/2000 00:48'!
orientation
	"Orientation is one of #vertical or #horizontal and determines on which axis this scroll bar lies."
	^orientation! !

!PrefabScrollBar methodsFor: 'API' stamp: 'cr 1/6/2000 00:48'!
orientation: aSymbol
	"Orientation is one of #vertical or #horizontal and determines on which axis this scroll bar lies."
	| fp |
	(#(horizontal vertical) includes: aSymbol)
		ifFalse: [self error: 'Orientation must be one of #horizontal or #vertical'].


	orientation = aSymbol
		ifTrue: [^self].

	fp := self fractionalPosition.

	self removeAllMorphs.

	forwardButton := nil.
	backwardButton := nil.
	slider := nil.
	sliderShadow := nil.

	orientation := aSymbol.

	self initializeMorph.

	self fractionalPositionQuiet: fp.
! !

!PrefabScrollBar methodsFor: 'API' stamp: 'cr 1/5/2000 05:17'!
ratio
	"Ratio of slider length to trough length expressed as a float."
	^ratio! !

!PrefabScrollBar methodsFor: 'API' stamp: 'cr 1/5/2000 05:17'!
ratio: aFloat
	"Ratio of slider length to trough length expressed as a float."
	ratio := aFloat.
	self updateSliderBounds.
! !

!PrefabScrollBar methodsFor: 'API' stamp: 'cr 1/5/2000 05:23'!
stepSize
	"Amount by which to change the slider position when one of the buttons is pressed.  This
	 is a float indicating how much to add to/subtract from the slider's fractional position."
	^stepSize! !

!PrefabScrollBar methodsFor: 'API' stamp: 'cr 1/5/2000 05:23'!
stepSize: aFloat
	"Amount by which to change the slider position when one of the buttons is pressed.  This
	 is a float indicating how much to add to/subtract from the slider's fractional position."
	stepSize := aFloat.! !

!PrefabScrollBar methodsFor: 'API-actions' stamp: 'cr 12/6/1999 00:21'!
action: aBlockOrSymbol
	"Set the action to 1) a block to evaluate when the slider is moved or 2) a message to send
	 to a specified target."
	response action: aBlockOrSymbol! !

!PrefabScrollBar methodsFor: 'API-actions' stamp: 'cr 12/6/1999 00:21'!
args: anArray
	"Set args to array of arguments to be used as parameters by action."
	response args: anArray! !

!PrefabScrollBar methodsFor: 'API-actions' stamp: 'cr 12/6/1999 00:22'!
target: anObject
	"The object that gets the message when the slider is moved."
	response target: anObject! !

!PrefabScrollBar methodsFor: 'click-and-hold scrolling' stamp: 'cr 1/7/2000 01:30'!
advanceScroller
	"Advance the scroll bar by one length in the direction indicated by cnhDirection."
	self fractionalPosition: self fractionalPosition + cnhDirection.! !

!PrefabScrollBar methodsFor: 'click-and-hold scrolling' stamp: 'cr 1/8/2000 00:43'!
startScrollingTowardPointer: evt
	"Begin scrolling by moving the slider toward the point in 'evt' which should be in the scrollbar's trough.
	 The slider moves by one length immediately, then delays a bit, after which it moves by a length
	 periodically, as determined by the result of 'self stepTime'.  This method advances the slider immediately
	 on the click, then starts stepping.  Releasing the mouse button should stop stepping."
	| ad sign |
	ad := self activeDimension.
	sign := (evt cursorPoint - slider bounds origin dotProduct: ad) sign.

	cnhDirection := (slider extent dotProduct: ad) asFloat / (self usableSliderArea extent dotProduct: ad) * sign.

	self advanceScroller.

	ignoreSteps := 3.
	self startStepping.
! !

!PrefabScrollBar methodsFor: 'click-and-hold scrolling' stamp: 'cr 1/8/2000 00:52'!
step
	"Advance the scroller only if ignoreSteps is zero.  Otherwise, decrement it.
	 This lets us delay for a bit, then scroll at regular intervals."
	(ignoreSteps > 0)
		ifTrue: [
			ignoreSteps := ignoreSteps - 1.
			^self.
		].

	self advanceScroller.! !

!PrefabScrollBar methodsFor: 'click-and-hold scrolling' stamp: 'cr 1/8/2000 00:44'!
stepTime
	^200! !

!PrefabScrollBar methodsFor: 'click-and-hold scrolling' stamp: 'cr 1/8/2000 00:58'!
wantsSteps
	"We don't want steps at startup, only while the left button is down."
	^false.! !

!PrefabScrollBar methodsFor: 'events' stamp: 'cr 1/7/2000 00:43'!
handlesMouseDown: evt
	^true
! !

!PrefabScrollBar methodsFor: 'events' stamp: 'cr 1/7/2000 01:25'!
mouseDown: evt
	self startScrollingTowardPointer: evt.! !

!PrefabScrollBar methodsFor: 'events' stamp: 'cr 11/2/1999 00:13'!
mouseDownInSlider: event
	slider color: Color veryVeryLightGray.
	sliderShadow bounds: slider bounds.
	sliderShadow show.! !

!PrefabScrollBar methodsFor: 'events' stamp: 'cr 1/7/2000 01:24'!
mouseUp: evt
	self stopStepping! !

!PrefabScrollBar methodsFor: 'events' stamp: 'cr 11/2/1999 00:13'!
mouseUpInSlider: event
	slider color: Color veryLightGray.
	sliderShadow hide.! !

!PrefabScrollBar methodsFor: 'events' stamp: 'cr 12/31/1999 00:16'!
sliderDragged: event
	"Event handler.  Position slider based on mouse location."	
	| p |
	p := event targetPoint adhereTo: self usableSliderArea.

	self moveSliderToPoint: p.
	response invokeWith: self fractionalPosition.! !

!PrefabScrollBar methodsFor: 'events' stamp: 'cr 1/5/2000 05:50'!
stepBackward
	"Backward button pressed."
	self fractionalPosition: self fractionalPosition - stepSize.! !

!PrefabScrollBar methodsFor: 'events' stamp: 'cr 1/5/2000 05:49'!
stepForward
	"Forward button pressed."
	self fractionalPosition: self fractionalPosition + stepSize.! !

!PrefabScrollBar methodsFor: 'change reporting' stamp: 'cr 1/5/2000 05:45'!
layoutChanged
	"Make sure all elements are positioned correctly after a resize."
	
	(forwardButton notNil and: [backwardButton notNil])
		ifTrue: [

			forwardButton extent: self buttonExtent.
			backwardButton extent: self buttonExtent.

			self isVertical
				ifTrue: [
					forwardButton
						position: self innerBounds bottomLeft 
									- (0 @ (forwardButton bounds height)).
					backwardButton 
						position: self innerBounds origin.
				] ifFalse: [		
					forwardButton 
						position: self innerBounds topRight 
							- (backwardButton bounds width @ 0).

					backwardButton
						position: self innerBounds origin.
				].

		].

	slider
		ifNotNil: [
			slider position: (slider bounds origin * self activeDimension) 
							+ (self innerBounds origin * self inactiveDimension);
				extent: self sliderExtent.
		].

	super layoutChanged.! !

!PrefabScrollBar methodsFor: 'dimensions' stamp: 'cr 11/1/1999 00:55'!
activeDimension
	"Return a point which, when multiplied with another point, zeros the dimension not allowed
	 by the current orientation."

	orientation = #horizontal
		ifTrue: [^1@0]
		ifFalse: [^0@1].
! !

!PrefabScrollBar methodsFor: 'dimensions' stamp: 'cr 12/9/1999 03:10'!
buttonExtent
	"Return dimensions to assign to the buttons."
	self isVertical
		ifTrue: [^ (self innerBounds width) @ (self innerBounds width // 1.2)]
		ifFalse: [^ (self innerBounds height // 1.2) @ (self innerBounds height)].
! !

!PrefabScrollBar methodsFor: 'dimensions' stamp: 'cr 11/1/1999 22:40'!
inactiveDimension
	"Return a point which, when multiplied with another point, zeros the dimension allowed
	 by the current orientation."

	orientation = #horizontal
		ifTrue: [^0@1]
		ifFalse: [^1@0].
! !

!PrefabScrollBar methodsFor: 'dimensions' stamp: 'cr 12/6/1999 01:17'!
sliderExtent
	"Return the extent of slider based on the result of ratio."

	^(self totalSliderArea extent * self activeDimension * self ratio) rounded
		+ (self innerBounds extent * self inactiveDimension)! !

!PrefabScrollBar methodsFor: 'dimensions' stamp: 'cr 1/5/2000 05:46'!
totalSliderArea
	orientation = #horizontal
		ifTrue: [^backwardButton bounds topRight corner: forwardButton bounds bottomLeft]
		ifFalse: [^backwardButton bounds bottomLeft corner: forwardButton bounds topRight]! !

!PrefabScrollBar methodsFor: 'dimensions' stamp: 'cr 1/5/2000 05:47'!
usableSliderArea
	"Return the rectangle that can contain the forward edge of the slider."
	self isHorizontal
		ifTrue: [
			^backwardButton bounds topRight corner: 
					forwardButton bounds bottomLeft - (slider width @ 0)
		] ifFalse: [
			^backwardButton bounds bottomLeft
				corner: (forwardButton bounds topRight) - (0 @ slider height).
		].! !

!PrefabScrollBar methodsFor: 'construction' stamp: 'cr 1/8/2000 01:31'!
attributeList
	"Return a collection of pairs of (attributeName: value) that can be used to reconstruct
	 this prefab completely."
	^super attributeList
		add: {#orientation:. self orientation};
		yourself.
! !

!PrefabScrollBar methodsFor: 'menu' stamp: 'cr 1/8/2000 01:54'!
addCustomMenuItems: aCustomMenu hand: aHandMorph
	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	
	aCustomMenu add: 'Set orientation' target: self action: #setOrientation.! !

!PrefabScrollBar methodsFor: 'menu' stamp: 'cr 1/8/2000 01:53'!
setOrientation
	"Set orientation interactively."
	| orientations index |
	orientations := #(horizontal vertical).

	index := (PopUpMenu labels: 'horizontal\vertical' withCRs)
				startUpWithCaption: 'Pick an orientation'.

	self orientation: (orientations at: index).! !

!PrefabScrollBar methodsFor: 'others' stamp: 'cr 12/6/1999 00:52'!
isHorizontal
	^orientation = #horizontal! !

!PrefabScrollBar methodsFor: 'others' stamp: 'cr 11/10/1999 01:07'!
isVertical	
	^orientation = #vertical! !

!PrefabScrollBar methodsFor: 'private' stamp: 'cr 12/31/1999 00:13'!
moveSliderToPoint: aPoint
	"Position slider at aPoint."	
	
	| ft |

	self isVertical
		ifTrue: [
			ft := self innerBounds left @ aPoint y.
		] ifFalse: [
			ft := aPoint x @ self innerBounds top.
		].

	slider position: ft.

! !

!PrefabScrollBar methodsFor: 'private' stamp: 'cr 12/31/1999 00:14'!
sliderPosition: anInteger
	"Position slider based on anInteger."	
	
	| area p |
	area := self usableSliderArea.
	p := (self activeDimension * anInteger) + area origin adhereTo: area.

	self moveSliderToPoint: p
! !

!PrefabScrollBar methodsFor: 'private' stamp: 'cr 1/2/2000 15:45'!
updateSliderBounds
	"Configure the slider size to reflect the current state of things."
	slider bounds: (self totalSliderArea origin extent: self sliderExtent).

! !

Smalltalk renameClassNamed: #RubberSheetLayout as: #RubberSheetResizer!

!RubberSheetResizer commentStamp: 'cr 2/27/2000 01:46' prior: 0!
This is a PrefabLayout that moves and stretches the clients so that they are always the
same size *relative* to the manager's size--that is, they stretch or shrink to match
the window's size.  This is occasionally useful, but frankly, it almost always sucks.
You will usually want to use a FixedDistanceResizer instead.

Internally, parcels are stored as fractional sizes on a rectangle of size 0@0 extent: 1@1.
For example, a parcel occupying the top-left quarter of the manager will be stored
as 0@0 extent (1/2)@(1/2).

!

!RubberSheetResizer methodsFor: 'resize policy' stamp: 'cr 2/23/2000 21:07'!
convertRect: aMorph
	"Transform aMorph's bounds to one with coordinates as fractions of the
	 manager's dimensions."
	^(aMorph bounds translateBy: window innerBounds origin negated) scaleBy: 1 / window extent.! !

!RubberSheetResizer methodsFor: 'resize policy' stamp: 'cr 7/17/1999 23:09'!
newSizesDo: aBlock
	"Evaluate aBlock, a two-argument block, over all parcels where arg1 is the morph and
	 arg2 is the parcel scaled to fit the current size of the window.  This gets called when
	 clients need to be resized."

	| parcel |
	parcels associationsDo: [ :assoc |
		parcel := (assoc value scaleBy: window innerBounds extent)
					translateBy: window innerBounds origin.
		aBlock value: assoc key value: parcel rounded.
	].
! !


!SwitchElement commentStamp: 'cr 2/27/2000 18:53' prior: 0!
In a check- or radio-button, this class implements the actual button part of it, (as opposed to the label part on
the right).  Used by PrefabRadioButton and PrefabCheckButton.!

!SwitchElement reorganize!
('appearances' click correctLook incorrectLook unClick)
('event handling' mouseDown: mouseMove: mouseUp:)
('private' swapColors)
('initialization' initialize)
('state' isClicked isClicked:)
('attributes' clickedColor: toggleMode: unclickedColor:)
!


!SwitchElement methodsFor: 'appearances' stamp: 'cr 7/18/1999 18:37'!
click
	"Make button be drawn selected."

	borderColor = #inset
		ifTrue: [^self].

	self borderColor: #inset.
	self swapColors.
! !

!SwitchElement methodsFor: 'appearances' stamp: 'cr 7/18/1999 19:00'!
correctLook
	isClicked
		ifTrue: [self click]
		ifFalse: [self unClick].! !

!SwitchElement methodsFor: 'appearances' stamp: 'cr 7/18/1999 19:05'!
incorrectLook
	"Set look to be the opposite of clicked state."
	isClicked
		ifFalse: [self click]
		ifTrue: [self unClick].! !

!SwitchElement methodsFor: 'appearances' stamp: 'cr 7/18/1999 18:45'!
unClick
	"Make button be drawn deselected."

	self borderColor = #inset
		ifFalse: [^self].

	self borderColor: #raised.
	self swapColors.
! !

!SwitchElement methodsFor: 'event handling' stamp: 'cr 7/18/1999 19:06'!
mouseDown: evt

	clickedIn := true.
	self incorrectLook.! !

!SwitchElement methodsFor: 'event handling' stamp: 'cr 7/18/1999 19:09'!
mouseMove: evt
	"If the pointer was moved out of the button's perimeter without the blue button being
	 released, unpress the button without performing the action."

	(self containsPoint: evt cursorPoint)
		ifFalse: [
			clickedIn := false.
			self correctLook.
		].

! !

!SwitchElement methodsFor: 'event handling' stamp: 'cr 1/19/2000 00:22'!
mouseUp: evt

	clickedIn
		ifFalse: [^self].

	clickedIn := false.

	(isClicked and: [toggleMode not])
		ifTrue: [^self correctLook].
	
	isClicked := isClicked not.
	self correctLook.

	response invoke.		"Ick!! Direct access to superclass's instant variable."
! !

!SwitchElement methodsFor: 'private' stamp: 'cr 7/18/1999 18:17'!
swapColors
	"Swap color and otherColor."
	| old |
	old := self color.
	self color: otherColor.
	otherColor := old.
! !

!SwitchElement methodsFor: 'initialization' stamp: 'cr 7/25/1999 16:59'!
initialize
	super initialize.
	isClicked := false.
	otherColor := Color blue.  "Changed by owner."

	toggleMode := true.

	"Get rid of the label."
	labelMorph delete.
	labelMorph := nil.
	labelMorphMaxSize := nil.
! !

!SwitchElement methodsFor: 'state' stamp: 'cr 7/18/1999 18:12'!
isClicked
	^isClicked.
! !

!SwitchElement methodsFor: 'state' stamp: 'cr 7/25/1999 00:23'!
isClicked: aBoolean
	isClicked := aBoolean.
	self correctLook.! !

!SwitchElement methodsFor: 'attributes' stamp: 'cr 7/18/1999 18:20'!
clickedColor: aColor
	isClicked
		ifTrue: [self color: aColor]
		ifFalse: [otherColor := aColor].! !

!SwitchElement methodsFor: 'attributes' stamp: 'cr 7/25/1999 16:39'!
toggleMode: aBoolean
	"If true, clicking on a SwitchElement twice restores it to its original stat.  Otherwise,
	 it sticks in clicked state until reset.  Hence the difference between a check button
	 and a radio button."

	toggleMode := aBoolean.! !

!SwitchElement methodsFor: 'attributes' stamp: 'cr 7/24/1999 23:34'!
unclickedColor: aColor
	isClicked not
		ifTrue: [self color: aColor]
		ifFalse: [otherColor := aColor].! !


!TestWidget methodsFor: 'as yet unclassified' stamp: 'cr 3/26/2000 20:16'!
buildOn: aManager
	"Caution--automatically-generated method."

	aManager
		extent: 567@443;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		minSize: 10@10;
		maxSize: 1073741823@1073741823.

	aManager addClient: (PrefabFrame new
		extent: 115@160;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		style: #inset;
		yourself)
		atRelPosition: 11@183.

	aManager addClient: (PrefabFrame new
		extent: 227@160;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		style: #inset;
		yourself)
		atRelPosition: 11@11.

	aManager addClient: (PrefabFrame new
		extent: 71@60;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		tag: #innermost;
		style: #inset;
		yourself)
		atRelPosition: 149@22.

	aManager addClient: (PrefabCheckButton new
		extent: 77@30;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		text: 'Hubris';
		contentOrientation: #left;
		yourself)
		atRelPosition: 19@227.

	aManager addClient: (PrefabLabel new
		extent: 82@16;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		text: 'Bitmap';
		contentOrientation: #left;
		yourself)
		atRelPosition: 27@39.

	aManager addClient: (PrefabLabel new
		extent: 66@24;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		text: 'Checklist';
		contentOrientation: #left;
		yourself)
		atRelPosition: 27@207.

	aManager addClient: (PrefabCheckButton new
		extent: 93@30;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		text: 'Impatience';
		contentOrientation: #left;
		yourself)
		atRelPosition: 19@255.

	aManager addClient: (PrefabLabel new
		extent: 46@48;
		color: (Color r: 0.844 g: 0.844 b: 0.844);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		image: #question;
		contentOrientation: #centered;
		yourself)
		atRelPosition: 158@25.

	aManager addClient: (PrefabRadioButton new
		extent: 131@30;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		text: 'info';
		contentOrientation: #left;
		yourself)
		atRelPosition: 23@131.

	aManager addClient: (PrefabCheckButton new
		extent: 85@30;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		text: 'Laziness';
		contentOrientation: #left;
		yourself)
		atRelPosition: 19@283.

	aManager addClient: (PrefabRadioButton new
		extent: 87@30;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		text: 'question';
		contentOrientation: #left;
		yourself)
		atRelPosition: 23@83.

	aManager addClient: (PrefabRadioButton new
		extent: 71@30;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		text: 'bang';
		contentOrientation: #left;
		yourself)
		atRelPosition: 23@59.

	aManager addClient: (PrefabListBox new
		extent: 155@160;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		elementHeight: 12;
		selectColor: (Color r: 0.71 g: 0.71 b: 0.71);
		selectForeground: (Color r: 1.0 g: 0.0 b: 0.0);
		selectionMode: #single;
		yourself)
		atRelPosition: 251@11.

	aManager addClient: (PrefabRadioButton new
		extent: 95@30;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		text: 'doNotEnter';
		contentOrientation: #left;
		yourself)
		atRelPosition: 23@107.
! !

!TestWidget methodsFor: 'as yet unclassified' stamp: 'cr 3/26/2000 20:15'!
initialize
	super initialize.
	self buildOn: self.! !


Prefab initialize!
PrefabCheckButton removeSelector: #orientation!
PrefabCheckButton removeSelector: #orientation:!
PrefabManager removeSelector: #extentFromWrapper:!
PrefabConstruction removeSelector: #constructionMenu:!
Smalltalk removeClassNamed: #PrefabFileList!
